// #define DEBUG 1 // remove!!! JS 2010-04
#define SLOW_MPI 0                               /* old version, obsolete */
#define MAX_out 1000        /* maximum lines for debugging/verbose output */
/* alpha dependency of terms (ToDo: and everything model specifique else) */ 
#ifndef USR_FILE   // may be defined outside
// * * * these files are used for models with external field * * *
//#define USR_FILE  "sample_bipartite_external_field.c"
//#define USR_FILE  "sample_bipartite_external_field_j_j_dash.c"
//#define USR_FILE  "sample_triangle_external_field_1.c"
//#define USR_FILE  "sample_triangle_external_field_2.c"
//#define USR_FILE  "sample_lc_j1j2j3.c"
//#define USR_FILE  "sample_lc_mf.c"
//#define USR_FILE  "sample_SrCuBO.c"
//#define USR_FILE "../documentation/stag_gen_ccm/sample_stag_spiral.c"
//#define USR_FILE "sample_kagome_volborthite.c"
//#define USR_FILE "sample_j1j2j3_honeycomb_model_state_III.c"
#endif
// Macros set outside:
//#define CFG_NoBra 1    // dont compute bra, ket + Eg only (RZinke, faster)
//#define TinyDelta 1e-5 // compute Delta-2*tinyDelta ... Delta+2*tinyDelta
//
// Warning: fidelity code and results are not verified (JS-2010-06)
// fidelity only supported for single thread code 
// Jun2010 DJJF Fidelity Code (0=disable, 1=enable, ...
// Nov2010 DJJF  ... 2=enable for even numbers of spin flips in clusters only)
#ifndef FIDELITY
#define FIDELITY 0 // default=2 ? its nonparallel and therefore slow
#endif

/*

  /-------------------------------------------------\
  |                                                 |
  |                                                 |
  |     /=====\     /=====\     |\          /|      |
  |    /       \   /       \    | \        / |      |
  |    |           |            |  \      /  |      |
  |    |           |            |   \    /   |      |
  |    \       /   \       /    |    \  /    |      |
  |     \=====/     \=====/     |     \/     |      |
  |                                                 |
  |                                                 |
  \-------------------------------------------------/

  ===================================================

  Name:      CCM (solve.C)
  
  Written by: Damian J. J. Farnell

  Date:      Wed Mar 15 15:20:28 GMT 2000

  Updated:   Joerg Schulenburg 2004-2008

  ===================================================

  ---------------------------------------------------

  PROGRAM NAME: SOLVE.C 

  PURPOSE: Routine that solves saved CCM
           equations using newton-raphson
	   or direct iteration. Sublattice
           magnetisation determined and 
	   ground-state energy (+ derivatives).

  ---------------------------------------------------

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

// #include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "Constants.h"
#include "Externals.h"
#include "FunctionPrototypes.h"
#include "nr.h"
#include "nrutil.h"
#include "storage.h"
// #include "f2c.h" 
//typedef long int logical;  // JS1002 f2c.h removed, reduce complexity
//#include "eispackd.h" // JS1002 eispack.c reduced
int rg_(long *nm, long *n, double *a, double *wr, double *wi,
        long *matz, double *z, long *iv1, double *fv1, long *ierr);

#if (PARALLEL_FLAG>0)
#include <mpi.h>
#endif

#ifndef FIDELITY    // defined in Constants.h
#define FIDELITY 0  // disabled is default (may change in future)
#endif // ifndef FIDELITY
#if FIDELITY
// fidelity code added by DJJF Jun2010
double *obx, *ox; // JS: old bra and ket vectors (from last parameter set)
double findFidelity(double *obx, double *ox, double *x, double *fidelity2, double *weight);
double findFidelityContrib(int length,int (*configuration)[5],
   int index,double *ox,double *x,int *permutationfactor, double *ci);
void findCICoefficient(int index, int length, int (*configuration)[5],
                      int (*allocation),
                int m, int *y, double *ox,
                double *x,double *subtotal,double *ci,int *permutationfactor);
// Jun08 Joerg new: find DescriptorIndex from Cluster (one call)
//   return <= 0 (not found), >=1 (found) 
int findClusterIndex(int order, int (*config0)[5]); // obtain.c
int findEmbeddingConstant(int index);
double *embedding;
double *oldC;
#endif // if FIDELITY

extern int *cfg_thread; // see define.c (load balancing)

#ifdef momentum
#warning "macro momentum is replaced by option -w since Jan2010"
#undef momentum
#endif
/* momentum of convergence for direct iteration
 * next vector is a mixture of momentum*oldX + (1-momentum)*newX
 * high momentum is more stable but slower
 * low  momentum is faster but probably dont converge
 * JS-Jan2010: was a macro, but now can be changed at runtime by option -m
 */
double momentum=0.75; // 0.625 0.75  old: 0.7 (look at j1j2_square_Neel)

// char gs_name[100]="";
// char input_name[200];
// char configurations[200];
int mapping[100]={0}; 
 /* The variable called "mapping" maps the 81 terms in the excited-state 
    equations to specific terms in the ground-state equations. 
    This is so that the "term" variable in the definition of the 
    delta[bonds][term] is correct. Again, seems to work quite well! */

/*  2010-04-23 JS define the startvector!
 * old version: x[1..nC]= 1e-7 (1e-6, SearchAlphaMin==1) bra=1e-9 ex=1e-2
 */
int setStartX(int nC, double *ket, double *bra){
  int i;
  if ((!myid) && Control.output>-1)
    printf(" Control.StartX= %d\n", Control.startx);
  switch (Control.startx) {
  case  0:  if (ket) for (i=1;i<=nC;i++) ket[i]=1e-6; // JS-20110404 fix i<nC
            if (bra) for (i=1;i<=nC;i++) bra[i]=1e-9;
            break;
  case  1:  if (ket) for (i=1;i<=nC;i++) ket[i]=1e-7;
            if (bra) for (i=1;i<=nC;i++) bra[i]=1e-9;
            break;
  case  2:  if (ket) for (i=1;i<=nC;i++) ket[i]=1e-7;
            if (bra) for (i=1;i<=nC;i++) bra[i]=1e-9;
            ket[1] = 0.1;  // see triangle-5-5
  // ket[2]=ket[1]=0.136; // triangle_field_2 better startvect? sub-4-4 
  // ket[1]=0.1; // testwise, ToDo: failes, why?
            break;
  case  4:
  case  5:  if (ket || bra) {
              int length;
              int configuration[MAX_SUBN+1][5];
              for (i=1;i<=nC;i++) {
      length=findClusterFromDescriptor(spinConfigurations[i].descriptor,
                                           configuration);
                if (ket) ket[i]=1e-7+1e-7*((1<<10)>>(2*length));
                if (bra) bra[i]=1e-9+1e-9*((1<<10)>>(2*length));
                if (Control.startx==5 && ket)
                  ket[i]*=(rand()&3)/3.;
              }
            }
            break;
  default:  srand(Control.startx);
            if (ket) for (i=1;i<=nC;i++) ket[i]=1e-7*((rand()&65535)-32768);
            if (bra) for (i=1;i<=nC;i++) bra[i]=1e-7*((rand()&65535)-32768);
  }
  return 0;
}

/* Parameter array of size Params.bonds d1*H1+d2*H2+... */
// JS091109:  fix exc-bug map81!=map62
// double (*delta)[62+1]=NULL;
double (*delta)[62+1]=NULL; // depends from usr_angle*usr_param=f(bond,term63)
double (*delta81)[81+1]=NULL; // fix exc-bug map81!=map62 
// delta  =(double (*)[62+1])malloc((Params.bonds+1)*(62+1)*sizeof(double));
// delta81=(double (*)[81+1])malloc((Params.bonds+1)*(81+1)*sizeof(double));

#ifdef USR_FILE // JS0812: was UseAlpha
// include user defined function usr_angle(bond,term13,*alpha,numalpha)
// Jun08 Joerg: includes USR_EXP_FILE in USR_FILE now (more simple)
#include USR_FILE
#endif

// now macros which may be defined in USR_FILE (JS 2008/12)
/*  UseAlpha: maximum number parameter alpha used
 *        0 = no parameter alpha (default)
 *        1 = set parameter  alpha[0]    was alpha in old version
 *        2 = set parameters alpha[0..1] was alpha, beta in old version
 *        3 = set parameters alpha[0..2] was alpha,beta,gamma (old version)
 *      ToDo: better defined in USR_FILE, here only default
 */
#ifndef UseAlpha
#define UseAlpha      0
#endif
/* start angle: ToDo: we need <UseAlpha=1..3> angles here */
#ifndef StartAlpha
//#define StartAlpha    0.0
//#define StartAlpha    (M_PI/6.0)   /* triangle AF in external field 1 */
#define StartAlpha    (0.5*M_PI)     /* triangle AF in external field 2 */
#define StepAlpha     (0.001*M_PI)   /* initial step of alpha */
#endif
#ifndef StopAlpha
#define StopAlpha     (StartAlpha + 2*M_PI) /* JS2011-07 for JR sample_*.c */
#endif
/*  SearchAlphaMin (meaning changed in v0904):
 *        0 = no search, alpha fixed (default)
 *        1 = raster 0..2Pi, 0..2Pi, 0..2Pi (for landscapes figures)
 *        2 = minimize energy by walking a 8 neighbour path
 *        3 = reserved for future
 */
#ifndef SearchAlphaMin     // do not minimize (default)
#define SearchAlphaMin 0
#endif
// set UseExpAlpha equal to 0 if you don't want to use user defined file
//        in find expectation values.
#ifndef UseExpAlpha
#define UseExpAlpha 0
#endif
#ifndef TOLERANCE_ALPHA       // may be defined in sample_*.c model spec.
#define TOLERANCE_ALPHA 1e-3  // the minimum Accuracy we want to have JS2011
#endif


// Random walk is simpler method for multi dimensional walks
// Jun08 Joerg: sample*expectation*.cpp added to sample*.cpp files
// Jun08 Joerg: alpha, beta, gamma replaced by alpha[0..2]
// ToDo: above declarations should be done in the USR_FILE (once!)

#ifndef RandWalk
#if   UseAlpha == 3
#define RandWalk 16 // 0 = no Random Walk Steps, 16 = max. 16 tests per step
#elif UseAlpha == 2
#define RandWalk  8 // 0 = no Random Walk Steps, 16 = max. 16 tests per step
#elif UseAlpha == 1
#define RandWalk  4 // 0 = no Random Walk Steps, 16 = max. 16 tests per step
#else
#define RandWalk  0 // 0 = no Random Walk Steps, 16 = max. 16 tests per step
#endif
#endif

/* -------------------------------------------------------------
 *  array of parameters depending on one variable parameter   
 *  sample: d1=cos(d), d2=sin(d) with H= d1*H1+d2*H2         
 */
static int PFLINE= __LINE__ + 1;   // this is only a localizator
// Joerg: depends from alpha only? can it depend from term (term13 or term63)?
// Joerg Jun08: remove term dependence
// double usr_parameter(int bonds, int term, double alpha)
#ifndef _USR_PARAMETER_   // may be defined in USR_FILE as string (comment)
double usr_parameter(int bonds, double alpha)
{
    /* add your model specifique parameter here! H=sum_i u(i,alpha)*H_i */
#if 1
#define _USR_PARAMETER_ "bond1=Delta"
  // square J1 J2 or xxzSquare
  //  tdelta * H1 + H2 + H3 + ...
  if (bonds==1) return alpha;
#elif 1
#define _USR_PARAMETER_ "bond1=bond2=Delta"
  // condition for triangular AF in external field: both model states
  if (bonds==1 || bonds==2) return alpha;
#else
#define _USR_PARAMETER_ "bond1=cos(Delta*Pi), bond2=sin(Delta*Pi), bond3=1"
  //  cos(alpha) * H1 + sin(alpha) * H2 + H3 + ...
  if (bonds==1) return cos(alpha*M_PI);
  if (bonds==2) return sin(alpha*M_PI); 
  if (bonds==3) return 1; 
#endif
  return 1.0;
}
#endif

double findEnergy(double *x);
void findExcitations(double *x, double *bra_x, double *alpha, double *ee);
void sublattice_term(int length, int (*configuration)[5], int *subTerm);
double findStagMag(double *x, double *bra_x, double *subLatticeMag);
void findBraState(double *x, double *bra_x);
void findBraStateRHS(double *rhs, double *x);
void findBraEquations(double **m, double *x);
int directIteration(int maximumNumIterations, int numConfigs, 
		    double tolerance, int *iterations, double *oldX);
int directIterationBraState(int maximumNumIterations, int numConfigs, 
			    double tolerance, int *iterations, 
			    double *oldX, double *oldBraX);
void subsetPrint(void); // define.C output subset rule
				
double *ex; // new code written 19 December 08 DJJF - direct iteration excited-state CCM
double *maxex; // new code written 19 December 08 DJJF - direct iteration excited-state CCM

void solve(void)
{
  int i, j, k;
  double *x, *bra_x; // ket and bra vector
  // index: 1..numConf, 0 used for code simplifications

  // char root_name[200], append[]=".dat";
  char output[200];
  //  char path[]="../Data/";
  //  char v_j2[]="_v_j2";
  //  int  **configuration, length;
  int iterations, iterations2, sum_it=0; /* ket, bra, allruns */
  double energy=0;
  //  double energy2;
  //  double specHeatA, specHeatC;
  int status=-1; // , stat;

  double stagMag=0.0;
  /* we need it to find the inflection points of E(p) curves */
  double Energy1, Energy2;
  double dEnergy, ddEnergy;
  double stagMag1, stagMag2;
  double dStagMag, ddStagMag;
  double alpha[3]={0.0, 0.0, 0.0}; // alpha, beta, gamma
  double excitationEnergy=0.0;
#if FIDELITY
  double fidelity=0;
  double fidelity2=0.0;
  double weight=0.0;
#endif // if FIDELITY
  
  double start, stop, tdelta;
  double subLatticeMag[MAX_UNIT_CELL+1]={0.0, 0.0};
  double *g_exp; // extra space for GSE expectation

  time_t t0_solve, t0, t1;
  
#if UseAlpha
  int status_search=0;  // counting invalid states on searches
  double d_alpha[3]={0.0,0.0,0.0}, // angle search accuracy or step
         oldE=1e9,      // last min found (last step to minimum)
         minE=1e9,      // min of neighbour step tests
         alpha_oldE[3]={0.0,0.0,0.0}, // angle for last minE found
         alpha_minE[3]={0.0,0.0,0.0}, // angle for minE of neighbour steps
         *x_minE=NULL, *x_oldE=NULL; // same for ket-vector

  // walking steps for min search
  // this walk is not random but tests vertices of a cube
  const int walkends[4]={ 1, 3, 9, 27}; // 3^UseAlpha - 1
  const int walkpath[27][3]={{ 0, 0, 0}, { 1, 0, 0}, {-1, 0, 0}, // 1d
                             { 1, 1, 0}, { 0, 1, 0}, {-1, 1, 0},
                             { 1,-1, 0}, { 0,-1, 0}, {-1,-1, 0}, // 2a
                             { 1, 1, 1}, { 0, 1, 1}, {-1, 1, 1},
                             { 1, 0, 1}, { 0, 0, 1}, {-1, 0, 1},
                             { 1,-1, 1}, { 0,-1, 1}, {-1,-1, 1},
                             { 1, 1,-1}, { 0, 1,-1}, {-1, 1,-1},
                             { 1, 0,-1}, { 0, 0,-1}, {-1, 0,-1},
                             { 1,-1,-1}, { 0,-1,-1}, {-1,-1,-1}}; // 3a
#endif // if UseAlpha

#if UseAlpha
#if SearchAlphaMin
  x_minE= dvector(0,NumberConfigurations+1);
  x_oldE= dvector(0,NumberConfigurations+1);
#endif // if SearchAlphaMin
#endif // if UseAlpha

#if FIDELITY
  /* v DJJF 2 June 2010: New Fidelity Code v */ 
  obx=dvector(0,NumberConfigurations+1);
  ox =dvector(0,NumberConfigurations+1);
  oldC=dvector(0,NumberConfigurations+1);
  embedding=dvector(0,NumberConfigurations+1);
  for(i=1;i<=NumberConfigurations;i++)  {
     ox[i] =0.0; 
     obx[i]=0.0;
	 embedding[i]=findEmbeddingConstant(i);
  }
  /* ^ DJJF 2 June 2010: New Fidelity Code ^ */ 
#endif // if FIDELITY

  g_exp=      dvector(0,2*(Params.nExpect+1)); /* extra space for GSE */

  // configuration=imatrix(0,MAX_SUBN+1,0,5);

  // now get the mappings right for the delta terms DJJF Jun08 Excitation
  //   map 1..81 to 1..62 [ to 1..13?]
  // see Externals.h map81[81+1] to 1..13 (remove mapping[81+1] to 1..62)
  
  for (i= 1;i<= 5;i++) mapping[i]= 2; // zz 1
  for (i= 6;i<= 6;i++) mapping[i]= 6; // z+ 2
  for (i= 7;i<=19;i++) mapping[i]= 8; // z- 3
  for (i=20;i<=20;i++) mapping[i]=14; // +z 4
  for (i=21;i<=33;i++) mapping[i]=16; // -z 5
  for (i=34;i<=36;i++) mapping[i]=22; // +- 6
  for (i=37;i<=39;i++) mapping[i]=24; // -+ 7 (no ++ 8)
  for (i=40;i<=73;i++) mapping[i]=27; // -- 9
  for (i=74;i<=74;i++) mapping[i]=54; // z  10
  for (i=75;i<=77;i++) mapping[i]=55; // -  11
  for (i=78;i<=81;i++) mapping[i]=58; // z^2 12 (no 13)
  for (i=1;i<=81;i++)
    if (map62[mapping[i]] != map81[i]) {
      printf("ERROR wrong mapping: map62[mapping[%d]]=%d != map81[%d]=%d\n",
              i, map62[mapping[i]], i, map81[i]);
    }
 
  //  solutionStrategy=1;

  if (!myid) subsetPrint(); // output subset rule (2nd time to be sure)
  time(&t0_solve);
  srand((int) t0_solve);

   // ToDo: remove _id000 (not needed if only one file)
// sprintf(input_name,    "%s.terms",  Control.name);
   sprintf(output,        "%s.output", Control.name);
// sprintf(configurations,"%s.configs",Control.name);
// sprintf(gs_name,       "%s_gs",     Control.name);
  if (Control.output<0) sprintf(output,"/dev/null"); // JS1002 make check

  if (Control.output > -1 && myid == 0) {
    printf("\n ======== SOLVE CCM EQUATIONS: START ALGORITHM ========\n\n");
  }

  if (myid==0) {
    printf(" solve: myid=%3d output=%s\n", myid, output);
    printf("  the .output-file is not be written anymore (JS 2010-09-19),\n"
           "  use ./tools/out2table.sh as a replacement for the old output,\n"
           "  this is for simplification of code and job management\n");
  }
#ifdef _USR_PARAMETER_
  if (myid==0) {
    printf("\n _USR_PARAMETER_(Delta): %s\n", _USR_PARAMETER_);
#ifdef SearchAlphaMin  // this was missing for easier support
    printf(" UseAlpha       %d\n", UseAlpha);
    printf(" SearchAlphaMin %d\n", SearchAlphaMin);
    printf(" StartAlpha/Pi %11.8f\n", StartAlpha /M_PI);
    printf(" StepAlpha/Pi  %11.8f\n", StepAlpha  /M_PI);
    printf(" StopAlpha/Pi  %11.8f\n", StopAlpha  /M_PI);
#endif
  }
#endif
  

  // ground-state energy equation.

  // fp_gs=fopen(gs_name,"r");
  
  Energy2=1.0;    Energy1=2.0;   /* set initial values, no meaning */
  stagMag2=1.0;   stagMag1=2.0;

  x=     dvector(0,NumberConfigurations); // x[0..n] = malloc(n+1)
  bra_x= dvector(0,NumberConfigurations); // JS 2011-03-10 0,nC+1 => 0,nC
  if (!x)     ERR("malloc ket_x");
  if (!bra_x) ERR("malloc bra_x");
  
  setStartX(NumberConfigurations, x, bra_x); // initialize x[1..nC], bra_x[]
  if (!myid && NumberConfigurations>1) { // JS 2011-03-10
    printf(" initialized x,bra[1]= %11.2e %11.2e\n",x[1],bra_x[1]);
    printf(" initialized x,bra[2]= %11.2e %11.2e\n",x[2],bra_x[2]);
  }
  
  // x[1]=0.1; // testwise, ToDo: failes, why?
  x[0]=    1.0; /* dummy index set to 1.0 for simplification, Joerg Sep05 */
  bra_x[0]=1.0; /* dummy index set to 1.0 for simplification, Joerg Sep05 */

//  if (solutionStrategy>1)
  {
    // new code written 19 December 08 DJJF - direct iteration excited-state CCM
    excitationEnergy=1.0;
    ex=      dvector(0,NumberExcitedConfigurations+5);
    maxex=   dvector(0,NumberExcitedConfigurations+5);
    for(i=1;i<=NumberExcitedConfigurations;i++)  {
       ex[i]=0.01; 
       maxex[i]=0.01;
    }
  }

   // Joerg Sep05: changing parameterfunction gives you more flexibility
  if (myid==0){ 
    printf("no usr_parameter detected at solve.C.%d\n", PFLINE);
    printf(" ... you may define it via USR_FILE in solve.C\n");
#ifdef USR_FILE
    printf(" ... here USR_FILE is defined as " USR_FILE "\n");
#endif
    printf(" solutionStrategy= %d (%s)\n",
             solutionStrategy,
           ((solutionStrategy==1)?"newton-raphson":"direct iteration"));
    printf(" TOLERANCE= %.2e momentum= %.3f (see Constant.h)\n",
             TOLERANCE,      momentum);
    // its helpful to see, what the user has choosen if he asks for support
    printf(" Control.output= %d\n", Control.output);
    if (Control.output<2)
     printf("Please enlarge output level to 2-3 before asking for support.\n");
  }
  /* array of parameters depending on one variable Parameter
   *  sample: d1=cos(d), d2=sin(d) with H= d1*H1+d2*H2
   */ 
  // JS-Feb10 dynamic allocation (may fit into CPU cache now? n*504B)
  // ToDo: malloc outside in input.c to avoid OOM after terms computed
  delta  =(double (*)[62+1])malloc((Params.bonds+1)*(62+1)*sizeof(double));
  delta81=(double (*)[81+1])malloc((Params.bonds+1)*(81+1)*sizeof(double));
  if ((!delta) || (!delta81)) {
    ERR("delta.malloc failed");
  }
  
#if UseAlpha
    alpha_oldE[0] = alpha_minE[0] = alpha[0] =  StartAlpha;  // starting angle
    alpha_oldE[1] = alpha_minE[1] = alpha[1] =  0;
    alpha_oldE[2] = alpha_minE[2] = alpha[2] =  0;
#ifdef StartAlpha1
    alpha_oldE[1] = alpha_minE[1] = alpha[1] =  StartAlpha1;
#endif
#ifdef StartAlpha2
    alpha_oldE[2] = alpha_minE[2] = alpha[2] =  StartAlpha2;
#endif
    d_alpha[0] = StepAlpha;  // starting angle step
    d_alpha[1] = StepAlpha;  // starting angle step
    d_alpha[2] = StepAlpha;  // starting angle step
#endif

  // ToDo: load checkpoint if requested (tdelta + x + bra_x)
  if (!myid)
    printf(" ToDo: read possible checkpoint data on demand x + bra_x\n");
  
  if (increment > 0.0) { start= minimum;  stop= maximum; }
    else               { start= maximum;  stop= minimum; }
  if (!myid) // JS1002
    printf(" Delta-Loop: %f - %f step %f\n", start, stop, increment);

  // loop over different couplings J, go from known to unknown angle
  // also go around rounding errors for decimal dual conversion
  int iTinyD=0; // needed to trigger computation of dE and ddE
  //   48bits deliver 48*l(2)/l(10) = 14.4 decimal digits
  //   we round up to 1e-12 for accumulated errors (typical loop 100)
  for(tdelta=start; fabs(tdelta-start)<=fabs(stop-start)+1e-12;
                    tdelta+=increment, iTinyD++) {
#ifdef TinyDelta
   // used to calculate suszeptibility from derivations
   //   dE= (E(d+h)-E(d))/h
   //  ddE= (E(d+h)+E(d-h)-2E(d))/(2h)  lim(h=TinyDelta)=0
   // compute: d + {-2, -1, 0} * (h=TinyDelta), three steps for ddE
   double old_tdelta=tdelta;
   // Willert_Sep09: 3 steps instead of 5 (old), use iTinyD
   for (iTinyD=0; iTinyD<=2; iTinyD++) {
    tdelta = old_tdelta + (iTinyD - 2) * TinyDelta; // -2, -1, 0
#endif

    // D1(Delta)*H1 + D2(Delta)*H2 + D3(Delta)*H3 + ... , Joerg Oct05
    if (myid==0)
    printf("\nModel Parameter Delta = %8.5f\n", tdelta);
// ToDo: replace by set_delta(in:tdelta,in:increment,out:delta)
{   int i;
    // JS10 obsolete: if (Params.bonds>MAX_BONDS) ERR("MAX_BONDS");
    for (i=1; i<= Params.bonds; i++) {
      int ja=1; /* start range */ 
      for (j=1; j<=81; j++)
        delta81[i][j] = usr_parameter(i, tdelta);
      for (j=1; j<=62; j++) {  // ToDo: use map62[1..62]
        delta[i][j] = usr_parameter(i, tdelta);
        if (j>1 && delta[i][ja]!=delta[i][j] && myid==0 && Control.output>1) {
          printf(" Delta[bond=%d][term=%d...%d]= %6.4f\n",i,ja,j-1,delta[i][ja]);
          ja=j; /* next range */
        }
      } // j=1..62 (terms)
      if (myid==0 && Control.output>1)
        printf(" set Delta[bond=%d][term=%d...%d]= %6.4f\n",i,ja,j-1,delta[i][ja]);
    } // for i=1..Params.bounds
} // int i
#if UseAlpha
    // find the the minimum E(angle), we assume that exact one minimum exist
    // increase accuracy of angle from 1e-1 to 1e-9 (interval)
    // ToDo: that seems not a good algorithm, use Newton method at least
    // go down with const steps, if it goes up, return with smaller steps
    // better algo, store last 5 lowest ergs(alpha[3]) or
    //    last steps(?) and MC in that region (random work?)
    // until 0902 min alpha[1] for fixed alpha[0], until min(alpha[0..1]) found
    //   rastering is slow
    // JS0902: random walk (alpha[0],alpha[1],alpha[2])
    //               range (d_alpha[0],d_alpha[1],d_alpha[2])*accuracyfactor
    // reduce d_alpha if no lower erg was found
#if SearchAlphaMin
  for(i=1;i<=NumberConfigurations;i++) x_minE[i]=x_oldE[i]=x[i];
#endif
    
    d_alpha[0] = fabs(StepAlpha); // start new minE(alpha) search, full range
    minE = oldE = 1.0e21; // biggest possible value
{
    // loop getting lowest energy by variing alpha = E_min(alpha)
    //  stop if delta_E_min is < TOLERANCE
    int numAlphaSteps;
    for (numAlphaSteps=0; // walkends[UseAlpha];
         ; // fabs(d_alpha[0]) > 2e-9; // JS-2011-07-11 not needed anymore (?)
         numAlphaSteps++) {

#if   SearchAlphaMin == 1  // raster full alpha range
       // for rastering we need a strong defined startvector
       setStartX(NumberConfigurations, x, bra_x);
       // for(i=1;i<=NumberConfigurations;i++) x[i]=    0.000001; 
       // for(i=1;i<=NumberConfigurations;i++) bra_x[i]=0.000000001; // ???
       if (numAlphaSteps) alpha[0]+=d_alpha[0];
       if (alpha[0]>=StopAlpha)     // overflow a[0] old: Stop=Start+2Pi
         { alpha[0]= alpha_oldE[0]; alpha[1]+= d_alpha[1];
           if (!myid) printf("\n"); // for easier gnuplot.splot
           d_alpha[0]=TOLERANCE_ALPHA; // alpha-loop end marker JS Oct09+Jul11
         }
#if UseAlpha==2  // two angles
       if (alpha[1]>=StopAlpha) break;
#endif
       if (alpha[1]>=StopAlpha)  // overflow a[1]
         { alpha[1]= alpha_oldE[1]; alpha[2]+=d_alpha[2]; } 
#if UseAlpha>=3  // three angles
       if (alpha[2]>=StopAlpha) break;
#endif
#elif SearchAlphaMin == 2  // walk along minimum path
       if (numAlphaSteps >= walkends[UseAlpha]) { // random walk
         if (!myid) {  // random() may differ between tasks!
           alpha[0]=alpha_oldE[0]+d_alpha[0]*(random()*2.0/RAND_MAX-1.0);
           alpha[1]=alpha_oldE[1]+d_alpha[0]*(random()*2.0/RAND_MAX-1.0);
           alpha[2]=alpha_oldE[2]+d_alpha[0]*(random()*2.0/RAND_MAX-1.0);
         }
#if (PARALLEL_FLAG> 0)
         MPI_Bcast(alpha,3,MPI_DOUBLE,0,MPI_COMM_WORLD);
#endif  
       } else
       { int jj = numAlphaSteps % walkends[UseAlpha]; // deterministic walk
         alpha[0]=alpha_oldE[0]+d_alpha[0]*walkpath[jj][0];
         alpha[1]=alpha_oldE[1]+d_alpha[0]*walkpath[jj][1];
         alpha[2]=alpha_oldE[2]+d_alpha[0]*walkpath[jj][2];
         // for simplicity d_alpha is equal for all directions
       }
       // we always start with +(0,0,0), this is not optimal but easy
       for(i=1;i<=NumberConfigurations;i++) x[i]=x_oldE[i]; 
#endif // if SearchAlphaMin == 1 or 2

#if SearchAlphaMin
       if (Control.output>1 && myid==0) {  // JS2010-11-22 +myid 
         int j;
         printf( " set alpha                  a/Pi=");
         for (j=0;j<UseAlpha;j++) printf(" % 10.8f", alpha[j]/M_PI);
         printf(" %5.0e aSteps= %4d\n", 
              fabs(d_alpha[0])/M_PI, numAlphaSteps );
       }
#endif

       for (i=1; i<= Params.bonds; i++) {
         for (j=1; j<=62; j++) {
           delta[i][j] = usr_angle(i,map62[j],alpha,UseAlpha)
                       * usr_parameter(i, tdelta);
         }
         for (j=1; j<=81; j++)
           delta81[i][j] = usr_angle(i,map81[j],alpha,UseAlpha)
                         * usr_parameter(i, tdelta);
       }
#endif
    iterations=0;
    iterations2=0;
    time(&t0);      // start time
    
    if (solutionStrategy==1) { // check that enough memory is available JS1002
      char *dummy1;
      dummy1 = (char *) malloc(sizeof(double)*(2+NumberConfigurations+1)
                                             *(  NumberConfigurations+1));
      if (!dummy1) { // NR needs O(nC^2) memory, DI only needs O(nC)
        printf("ERROR: solve.C test malloc failed, setting from NR to DI\n");
        solutionStrategy=2;
      }
      if (dummy1) free(dummy1);
      printf(
      "WARNING: NR may be much slower than DI (JS Apr2010, lc sub-7-19)\n");
      // ToDo: specify time as f(NumConf) (assuming O(NumConf^2) for bra)
    }

    // ToDo: set x to oldX (oldE) ???
    if (solutionStrategy==1) {
      
      // (a) newton-raphson ket state + LU decomp. bra state.
      // x(in,out) iterations(out), see num_methods.C
      status=mnewt((int) MAX_NUM_ITERATIONS, NumberConfigurations, 
		   (double) TOLERANCE, (double) TOLERANCE, &iterations, x);
      
    } else {
      
      // (b) direct iterations for both ket and bra states.

      status=directIteration((int) MAX_NUM_ITERATIONS,
             NumberConfigurations, (double) TOLERANCE, 
	     &iterations, x);
      // status=0 ok, status!=0 failure

    }
    time(&t1);  // status = 0 means OK, other values for errors

    sum_it += iterations; // sum for overall speed measuring

    if (iterations >= MAX_NUM_ITERATIONS || status) {
#if SearchAlphaMin>1
       status_search++; // count invalid search points
#endif
       for(i=1;i<=NumberConfigurations;i++) x[i]= 0.0;
       energy = 0.0;
       if (!status) status=-10;
    } else
      energy=findEnergy(x);

#if !UseAlpha
    if (Control.output>0 && myid==0) // print out later?
        printf(" %5d Eg= % 16.12f Eg.i100t[min]= % 6.2f  sum_it= %6d\n",
           ((status)?-1:1)*iterations, energy, (t1-t0)/.6/iterations, sum_it);
#else // UseAlpha
      // ToDo: reduce output for UsaAlpha<3
      if (Control.output>0 && myid==0) {
        int j;
        printf(" %5d Eg= % 16.12f", ((status)?-1:1)*iterations, energy);
        printf(" a/Pi=");
        for (j=0;j<UseAlpha;j++) printf(" % 10.8f", alpha[j]/M_PI);
#if SearchAlphaMin
        printf(" %5.0e aSteps= %4d", d_alpha[0]/M_PI, numAlphaSteps);
#endif
        printf(" sum_it= %6d\n", sum_it);
      }
#if SearchAlphaMin
      // minE is the minimum neighbour, oldE is the last position
      if (energy<minE && status==0 && iterations<MAX_NUM_ITERATIONS) { // JS0904
         minE = energy;      // minE of surrounding test steps
         alpha_minE[0] = alpha[0];
         alpha_minE[1] = alpha[1];
         alpha_minE[2] = alpha[2];
         for(i=1;i<=NumberConfigurations;i++) x_minE[i]=x[i]; 
#if SearchAlphaMin == 1   // JS Oct09
         if (minE < oldE) { oldE = minE;  // last taken step value
           // JS-2011-04-05 see sample_kagome_volborthide.ccm Bug?
           for(i=1;i<=NumberConfigurations;i++) x_oldE[i]=x_minE[i]; 
         }
#endif
#if SearchAlphaMin == 2
         // skip rest of random walk tests if we have lower neighbour
         if (numAlphaSteps+1 >= walkends[UseAlpha])
             numAlphaSteps += 10*RandWalk;
#endif
      } 
#if SearchAlphaMin == 2
      if (numAlphaSteps+1 >= walkends[UseAlpha]) { // ??? ToDo
       // JS2011-07-11 better stop at defined accuracy of alpha (+minE)
       //   we want to have both accuracies defined 
       if (fabs(minE - oldE) <= TOLERANCE
        && fabs(d_alpha[0])  <= TOLERANCE_ALPHA) break; 
        // stop if nothing was found
        if (minE < oldE) {
          // besser diffE<tolerance und schrittweite d_alpha < tolerance_a=1e-4
          // old.2011-07-11 if minE==oldE it iterates much longer
          //                if minE<oldE && minE-oldE<e-10 d_alpha may be bad
          //  if (fabs(minE - oldE) < TOLERANCE) break; // finish minE(alpha)
          oldE = minE;       // last taken step value
          alpha_oldE[0] = alpha_minE[0];
          alpha_oldE[1] = alpha_minE[1];
          alpha_oldE[2] = alpha_minE[2];
          for(i=1;i<=NumberConfigurations;i++) x_oldE[i]=x_minE[i]; 
          numAlphaSteps =  0; // restart walk around cycle
          status_search = -9; // we are lucky enough
        } else {
          if (numAlphaSteps+1 >= walkends[UseAlpha] + RandWalk) {
            d_alpha[0] *= 0.5; // reduce steps
            numAlphaSteps = 0; // skip +(0,0,0)
          }
        }
      }
#endif
#else  // no SearchAlphaMin
      break; /* stop alpha search, d_alpha[0] = accuracy */
#endif

    } /* numAlphaSteps, break if alpha and Emin is relaxed */
} // int numAlphaSteps
    // alpha=alpha_minE; energy=minE; // ???
#if SearchAlphaMin >= 1
    // set to min values for UseAlpha=0 outputs
    // ToDo: why we set to oldE here? should be minE!??? JS2011-04 check!
    alpha[0] = alpha_oldE[0] = alpha_minE[0]; // old: a=minA=oldA
    alpha[1] = alpha_oldE[1] = alpha_minE[1]; // new: a=oldA=minA 2011-04-05
    alpha[2] = alpha_oldE[2] = alpha_minE[2];
    energy = oldE = minE; // = oldE; JS-2011-04-05 was oldE and x_oldE?
    for(i=1;i<=NumberConfigurations;i++) x[i]=x_oldE[i]=x_minE[i];
    if (energy>=1.0e21) {  // nothing found (dont use bad convergation etc.)
      for(i=1;i<=NumberConfigurations;i++) { x[i]=0; x_oldE[i]=0.000001; }
      energy = minE = oldE = 0;
    }
    if (Control.output>-1 && myid==0) {
      int j;
      printf(" Eg(alpha) %16.12f a/Pi=", minE);
      for (j=0;j<UseAlpha;j++) printf(" % 10.8f", alpha[j]/M_PI);
      printf(" %5.0e\n", fabs(d_alpha[0])/M_PI); // accuracy Mar08, Feb09
    }
#endif  // SerchAlphaMin>=1
#endif  // UseAlpha

    // JS091021: add "|| status"
    if (iterations >= MAX_NUM_ITERATIONS || status) continue; // skip the rest
       // break;

    time(&t0);

#if !defined(CFG_NoBra)

    if (solutionStrategy==1) { // NR
      
     // (a) LU decomp. bra state.

      // x(in), bra_x(out)
      findBraState(x, bra_x); // findBraStateRHS + findBraEq + LUdcmp
      iterations2=1; // ???

    } else { // DI
      
      // (b) direct iterations for bra states.

      // ToDo: difference to initial state bra_x=0? JS09
      // x(in) bra_x(in(iterativ)?,out) iteratons2(out)
      status=directIterationBraState( (int)MAX_NUM_ITERATIONS, 
	     NumberConfigurations, (double)TOLERANCE, 
	     &iterations2, x, bra_x);
    } // NR + DI

    time(&t1);

    // (c) the (sub)lattice magnetisation.
      
    stagMag=findStagMag(x,bra_x,subLatticeMag);
    if (iterations2 < 0) stagMag=0.0; // set ErrorFlag
	
    if (Control.output>0 && myid==0) // print out later?
        printf(" %5d M=  % 16.12f Mg.i100t[min]= %6.2f\n",
           iterations2, stagMag, (t1-t0)/.6/iterations2);
    
#if FIDELITY
    /* v DJJF 2 June 2010: New Fidelity Code v */ 
    fidelity = findFidelity(obx, ox, x, &fidelity2, &weight);
    // JS.ToDo: better local ox,obx!
    if (!myid)
      printf(" Fidelity=  % 16.12f Weight= %16.12f\n", fidelity2,weight);
    /* ^ DJJF 2 June 2010: New Fidelity Code ^ */ 
#endif // if FIDELITY
	
    // now find the generalised expectations.
	
    if (Control.greatExpectations) findGenExp(x,bra_x,g_exp,alpha);

#else
    stagMag = 0.0;
#endif  // CFG_NoBra

    time(&t0);

    excitationEnergy=0.0;
    if (Control.excitations)
      findExcitations(x,bra_x,alpha,&excitationEnergy);

    time(&t1);
    if (Control.excitations && Control.output>0 && !myid)  // DJJF Jun08
       printf("Excited-State Energy= %16.10f  GAP.t[min]= %6.2f\n",
              excitationEnergy, (t1-t0)/60.);
              
    // PRINT OUT INFORMATION.
    
    // we need at least two predecessing steps (iTinyD>=2)
    dEnergy  = ddEnergy  = 0;
    dStagMag = ddStagMag = 0;
    { // derivative
      double h = increment;
#ifdef TinyDelta
      h = TinyDelta;
#endif
      if (iTinyD>=1) dEnergy   = (energy -Energy1 )/(h);
      if (iTinyD>=1) dStagMag  = (stagMag-stagMag1)/(h);
      if (iTinyD>=2) ddEnergy  = (energy -2*Energy1 +Energy2 )/(h*h);
      if (iTinyD>=2) ddStagMag = (stagMag-2*stagMag1+stagMag2)/(h*h);
#ifdef TinyDelta
      if (iTinyD>1) // print only one of three steps
#endif
      if (Control.output > 0 && myid == 0) {
        if (iTinyD>=1) printf("Computational 1st Derivative Eg wrt delta = % f\n",dEnergy);
        if (iTinyD>=2) printf("Computational 2nd Derivative Eg wrt delta = % f\n",ddEnergy);
        if (iTinyD>=1) printf("Computational 1st Derivative  M wrt delta = % f\n",dStagMag);
        if (iTinyD>=2) printf("Computational 2nd Derivative  M wrt delta = % f\n",ddStagMag);
      } // Control.output > 0 && myid == 0
    } // derivative
    // = -d^2 E_g/ d Delta^2 via computational evaluation only.
    
    Energy2=Energy1;      Energy1=energy;   // save older values
    stagMag2=stagMag1;    stagMag1=stagMag;

    if (!myid) {
      // JS1002: 12.8f to 14.10f, sum_it removed (method dependend)
      // all imortant (model specifique) results into one line (make check)
#if UseAlpha // JS2010-05-31 we have less accuracy when minimizing alpha 
      printf("# D % 6.4f a/Pi", tdelta);
      for (k=0; k<UseAlpha; k++) printf(" % 8.6f", alpha_minE[k]/M_PI);
      printf(" E % 13.10f M % 9.6f G %9.6f\n",
	     energy, stagMag, excitationEnergy);
#else
      printf("# D % 6.4f E % 13.10f M % 13.10f G %13.10f\n",
	     tdelta, energy, stagMag, excitationEnergy);
#endif

      if (Control.output>0)
      printf("               -dEg = % 12.8f : Heat = % 12.8f\n"
             "ket[1]= % 12.9f [2]= % 12.9f\n"
             "bra[1]= % 12.9f [2]= % 12.9f\n",
	      -dEnergy, ddEnergy,
                 x[1],     x[(1%NumberConfigurations)+1],
             bra_x[1], bra_x[(1%NumberConfigurations)+1]);
      if (Control.output>0 && UnitCell.number>1 && iterations2>=0)
        for (k=1;k<=UnitCell.number;k++)
          printf("Mag[%d]= % 12.9f\n", k, subLatticeMag[k]);
#if UseAlpha
      for (k=0; k<UseAlpha; k++)
        printf("alpha[%d]/Pi= % 13.9f %5.0e\n",k,alpha_minE[k]/M_PI,
                                              fabs(d_alpha[k])/M_PI);
#endif
      if (Control.greatExpectations>0) {
        double sum_g_exp=0;
        for (k=1;k<=Params.nExpect;k++) {
          printf("# Expectation_Value= % 12.10f i= %2d\n", g_exp[k], k);
          sum_g_exp += g_exp[k];
        } // for k
        // old1002: "Lattice Magnetisation Triangular AF="
        printf("Sum_Expect_Values=   % 12.10f\n", sum_g_exp);
      } // if Control.greatExpectations>0

      if (Control.output > 0) {
        int i, j, j0, j1, j2; double minX=9999, maxX=-1;
        int *xsort=NULL, nCout, k1;
        
        nCout=4<<Control.output; if (nCout>1000) nCout=1000;
        if (nCout>NumberConfigurations) nCout=NumberConfigurations;
        xsort=(int *) malloc((nCout+1)*sizeof(int));
        if (xsort) for (i=1-1;i<=nCout;i++) xsort[i]=0;
        for(j0=j1=j2=0,i=1;i<=NumberConfigurations;i++) {
          if (xsort) 
          for (j=0;j<nCout;j++) {
            if (!xsort[j])       { xsort[j]=i; break; }
            if (fabs(x[i])<=fabs(x[xsort[j]])) continue;
            for (k1=nCout;k1>=j+1;k1--) xsort[k1]=xsort[k1-1];
            xsort[j]=i; break;
          } // for j
          if (fabs(x[i])< minX) minX=fabs(x[i]);
          if (fabs(x[i])> maxX) maxX=fabs(x[i]);
          if (     x[i] <-1e-9) j0++;
          if (fabs(x[i])< 1e-9) j2++; 
          if ( bra_x[i] <-1e-9) j1++;
        } // for i=1..NumberConfigurations
        printf("\nmaxX = max(|x[i]|) = % 8.6f\n", maxX);
        printf(  "minX = min(|x[i]|) = % 8.2e\n", minX);
        if (minX<1e-12*maxX) { // set a more practical zero border
            minX=1e-12; printf("minX/maxX<1e-12, set new minX=1e-12\n");
        }
        printf("number coefficients (x<-t,|x|<t,bra_x<-t,t=1e-9)   "
               " = %d %d %d  NC= %d\n", j0, j2, j1, NumberConfigurations);
        for(j0=j1=j2=0,i=1;i<=NumberConfigurations;i++) {
          if (     x[i] <-10*minX) j0++;
          if (fabs(x[i])< 20*minX) j2++; 
          if ( bra_x[i] <-10*minX) j1++;
        }
        printf("number coefficients (x<-t,|x|<t,bra_x<-t,t=10*minX)"
               " = %d %d %d  NC= %d\n", j0, j2, j1, NumberConfigurations);

        if (Control.output > 1) {
          int i,j; double sum=0,sumb=0,prod=0;
          for(i=0;i<nCout;i++) {
            j=i+1; if (xsort) j=xsort[i]; if (!j) continue;
            printf(" i x bra %4d % .10f % .10f", j, x[j], bra_x[j]);
            printOutClusterFromDescriptor(spinConfigurations[j].descriptor);
            sum+=x[j]*x[j]; sumb+=bra_x[j]*bra_x[j]; prod+=x[j]*bra_x[j];
          } // i=0..nCout-1
          printf(" x.x bra^2 x.bra  % .9f % .9f % .9f\n",sum,sumb,prod);
        } // if Control.output > 1
      } // if Control.output > 0
    } // if !myid 
#ifdef TinyDelta
   } // iTinyD   tdelta +/- TinyDelta
   tdelta=old_tdelta;
#endif

   if (!myid) {
     time(&t1);
     if (t1-t0_solve>NumberConfigurations/1000000*60+60) { // allow writing 8MB/60s
       // ToDo: set checkpoint: write NumConfigs, tdelta, x[i] + bra_x[i]
       printf(" ToDo: write checkpoint data x + bra_x\n");
       t0_solve= t1;
     }
   } // !myid

#if FIDELITY
   /* v DJJF 2 June 2010: New Fidelity Code v */ 
   for(i=1;i<=NumberConfigurations;i++) {  // JS: store old vectors
     obx[i]=bra_x[i];
     ox[i] =x[i];
   }
   /* ^ DJJF 2 June 2010: New Fidelity Code ^ */ 
#endif // if FIDELITY
  } // tdelta += increment

  if (Control.output > -1 && !myid)
    printf("\n ========= SOLVE CCM EQUATIONS: COMPLETED! =========\n\n");
  // fclose(terms_fp);    terms_fp=NULL;
  // ferase(fp_exp);
  // stat=remove(gs_name);
  // stat=remove(input_name);  
  // stat=remove(configurations);
}

/* called by solve() and directIteration(only_printout)
 * new: x[0]=1 now (Sep05)
 */
double findEnergy(double *x) 
{
  // indices renamed to idx (shorter code, better formatted)
  int i, bonds, idx[6]={0,0,0,0,0,0};
  double dummy, sum;

  sum=0.0;
  term_rewind(0);

  for(bonds=1;bonds<=Params.bonds;bonds++) {

    for(i=1;;i++) {
      
      term_get(0,idx,&dummy);  // get gse_terms, idx[0]=0 always
      if (idx[1]==STOP_TERM) break;  // JS 2010-04
      
#if DEBUG // keep code small for CPU Icache
      if (idx[2] < 0 || idx[2] > NumberConfigurations) ERR("bad index");
#endif
      
      // Joerg Sep05:
      //   according to gse_terms only idx[2..3] can be nonzero
      // gse_term{3}      : (i2,i3) = two single-site configs
      // gse_term{2,4,5,7}: (i2, 0) = two-site neighbour config
      // gse_term{1,6,8}  : ( 0, 0)
      // squareLSUB10 -> B1: (0,1,0,0,0,0,-0.5), B2: (0,27,1,0,0,0,-1.0)
      sum += dummy * x[idx[2]]
                   * x[idx[3]] * delta[bonds][idx[1]];
    }
  }
  return sum;
}
 
// in/out: oldX - startvector + iterationvector
// in/out: dx   - difference oldX(out) - oldX(in)  (only if precondition)
//                used to modify start vector (speed up?) -> removed
// return status 0=ok,  -N = error
int directIteration(int maximumNumIterations, int numConfigs, 
		    double tolerance, int *iterations, double *oldX)
{
  int i, j, bonds, max_ket_i=1, status=0;
  int idx[7]={0};
  double dummy;
  double xi2, xi3, xi4, xi5;
  double *lhs, *rhs, *tmp,    /* Joerg: left-hand side, right-hand side */ 
         min_error, error, newX;

  error     =  0.0; // JS Nov05
  min_error = 10.0; // JS Apr06, to stop divergence problems LSUB14 chain

  if (myid==0 && Control.output>((SearchAlphaMin)?1:0))
    printf("Direct iteration ket state (tolerance=%g, momentum=%g):\n",
            tolerance, momentum);

  lhs = dvector(0,numConfigs+5); // +5 ???, better +npe for balance?
  rhs = dvector(0,numConfigs+5);
  tmp = dvector(0,numConfigs+5); // for MPI

  for(i=1;i<=numConfigs;i++) {
    lhs[i]=0.0;
    rhs[i]=0.0;
    tmp[i]=0.0;
  }
  tmp[0]=0.0;
  lhs[0]=0.0;
  rhs[0]=0.0; // used as status/error flag, JS0904

  // for comparision old/new versions in case of trouble 
  if (Control.output > ((SearchAlphaMin)?1:0) && myid==0) {
   // for (i=1;i<=NumberConfigurations;i++)
   //   if (oldX[max_ket_i]<oldX[i])
   //            max_ket_i =     i;
    printf(" %5d Eg  %16.12f err %8.1e "
           "x_max %4d % 10.8f\n",
           0, findEnergy(oldX), error,
           max_ket_i, oldX[max_ket_i]);
  }

  
  for((*iterations)=1; (*iterations)<=maximumNumIterations; (*iterations)++) {
    
       // ToDo: call function term_eq(in:x,in:maxex,id=3,out:newex) ???
       // newex[i0]+=terms(x)*maxex[i2]; ???
    term_rewind(1); // .terms

    /* calculate rhs and lhs from input-file */
    for(bonds=1; bonds<=Params.bonds; bonds++) {
      
      /* why loop over bonds? inner loop does not depend on bonds? */
      for(i=1;;i++) {
	
        term_get(1,idx,&dummy);  // .terms
        if (idx[1]==STOP_TERM) break;
	
#if DEBUG // keep code small for CPU Icache
        if ((idx[0] <= 0 || idx[0] > NumberConfigurations)
         || (idx[2] <  0 || idx[2] > NumberConfigurations)) ERR("bad index");
#endif
        dummy *= delta[bonds][idx[1]];
        /* now: oldX[0]=1.0, Joerg Sep05 */
        xi2=oldX[idx[2]]; /* pointing to a configuration index or 0 */
        xi3=oldX[idx[3]];
        xi4=oldX[idx[4]];
        xi5=oldX[idx[5]]; /* 4 indices only for term34 */
    
        /* ToDo: indices are sorted, so that zeros are at end (idx[5]) */
        /* Joerg: we look for terms where idx[2]==idx[0] and rest 0 */
        if (idx[3]==0 && idx[2]==idx[0]) {
          tmp[idx[0]]-=dummy;                 // rarely (diagonal)
          // which terms? ToDo: sort as first!? (remove if construct!?
          // term2-4,54,58
        } else {
          rhs[idx[0]]+=dummy*xi2*xi3*xi4*xi5; // often (offdiagonal)
        }
      }
    }
    // lhs[] is the same after every loop! JS ToDo: speedup if outside
    // only lhs[j],rhs[j] for (((j-1)%npe) == myid) is non zero
    if ((*iterations)==1) {
#if (PARALLEL_FLAG> 0) 
      /* only every npe-th element is nonzero, summarize, old JS1002 */
      // for(j=1+myid;j<=numConfigs;j+=npe) tmp[j]=1.0/tmp[j];
      for(j=1;j<=numConfigs;j++)
        if (cfg_thread[j]==myid) tmp[j]=1.0/tmp[j]; // cfg_thread==myid
      // we simply sum, maybe Alltoall + reordering is faster
      MPI_Allreduce(tmp, lhs, numConfigs + 1,
                    MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
#else
      for(j=1;j<=numConfigs;j++) lhs[j]=1.0/tmp[j]; // expensive, do once
#endif
    }

    // only DEBUG (myid1=1 myid2=2 ... myid0=npe-1)
//    for(j=1+myid;j<=numConfigs;j+=npe) {  // parallel 1...
    for(j=1;j<=numConfigs;j++) if (cfg_thread[j]==myid) {  // parallel 1...
      /* old: using tolerance=1e-12 here is not a good idea!? */
      // usually lhs=-0.5,-1.0,... (see term2-4,54,58)
      //                     and delta[]=usr_parameter(tdelta)
      if (fabs(lhs[j])>1e9 && fabs(rhs[j])>1e7) {
        // sometimes (triangle h=2.8 a=(0,-0.5) rhs=2e-4, lhs=1/-9e-16) ???
        // if (rhs[0]==0.0 && Control.output>1) // print only once!
  	  printf("Error in direct iterations: no left-hand side...\n"
            "it= %4d id= %d cfg= %4d rhs= % .4e * lhs= % .4e, abort\n",
             *iterations, myid, j, rhs[j], lhs[j]);
        // rhs range?
        // rhs[j]=0;  // last chance?
        // system("sleep 1"); // give other tasks a chance to complain
        // MPI_Abort(MPI_COMM_WORLD, 1);
        rhs[0]=tmp[0]-=1.0; status=-4; // mark as bad!
#if EXIT_ON_ERROR
        ERR("no left-hand side");
#endif
      }
    }
#if (PARALLEL_FLAG> 0)
    /* only every npe-th element is nonzero, summarize */
//    for(j=1+myid;j<=numConfigs;j+=npe) tmp[j]=rhs[j]*lhs[j];
    for(j=1;j<=numConfigs;j++) if (cfg_thread[j]==myid) tmp[j]=rhs[j]*lhs[j];
    // rest of tmp[j(other tasks)] must be 0
    // store the sum of tmp to rhs incl. status lhs[0]
    MPI_Allreduce(tmp, rhs, numConfigs + 1,
                  MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
#else
    for(j=1;j<=numConfigs;j++) rhs[j]*=lhs[j];
#endif
    // now we can use single-task algorithm to go further
    // rhs[0] has summed errorstatus for parallel jobs   
    if (rhs[0]<0) { status=-3; break; }

    error=0.0;
    // err=error;
    // max_X_j=0; max_X=0.0; // only DEBUG
    for(max_ket_i=1, j=1;j<=numConfigs;j++) {
      newX = rhs[j];
      error+=fabs(oldX[j]-newX);
      oldX[j]=momentum*oldX[j]+(1.0-momentum)*newX; // some parallel overhead
      if (max_ket_i<1 || max_ket_i>numConfigs) ERR("DI bad max_ket_i");
      // valgrind reports "Conditional jump depends on uninitialised value(s)"
      if (fabs(oldX[max_ket_i])  // uninitialized value? which?
         <fabs(oldX[        j])) max_ket_i=j;
      // lhs[j]=0.0;
      rhs[j]=0.0;
      // ToDo: outside It.: if (fabs(oldX[j])>fabs(max_X)) {max_X=oldX[j]; max_X_j=j;}
    }
    
    /* calling findEnergy() here is a vast of time ??? (Joerg) */
    if ((Control.output > ((SearchAlphaMin)?1:0) && myid==0
      && (((*iterations) % 10)==0 
       || Control.output > 2 || error > 0.0625 || 2*min_error <= error))
#if SearchAlphaMin==0  // reduce output in search mode
      || (error < tolerance && !myid)  // always output if it will break
#endif
     ) {
      // err= sum(fabs(dX[i]),i) (i,dX[i])_for_max(fabs(dX[i])
      printf(" %5d Eg  %16.12f err %8.1e "
             "x_max %4d % 10.8f\n",
	     *iterations, findEnergy(oldX), error,
             max_ket_i, oldX[max_ket_i]);
    }

    if (isnan(error)) {   /* break if +-Inf or NaN */
       if (!myid && Control.output>1)
         printf(" iteration = %4d : energy = %16.10f : "
                "error = %14.12f\nError directIteration: NaN-BREAK\n",
                *iterations, findEnergy(oldX), error);
       status=-4;
#if EXIT_ON_ERROR
        ERR("NaN");
#endif
       break;
    }

    if (min_error > error) min_error = error;
    if (error < tolerance) break; // convergence

    if ( (error > 4*min_error && error > 1e-4 && (*iterations) > 99)
      || (error > 10 && (*iterations) > 10)
      || status < 0 ) { // divergence? or rhs/lhs=NaN
        // change momentum OR set new random startvec OR add small random vec?
        min_error = 1e+11;
//      for(j=1;j<=numConfigs;j++) oldX[j]=0.00001;
        for(j=1;j<=numConfigs;j++) oldX[j]=0.000001;
//        oldX[1]=oldX[2]=0.18;
        // better set momentum outside, bad on search and raster else
        // momentum=(1.0+3*momentum)/4; // more to 1.0, smaller changes on ket_x[x]
        if (!myid && Control.output>1)
          printf("Warning: no convergence, reset x, status=-2, break\n");
        // some times it converges for higher momentum, but often not
        if (status==0) status=-2; 
        break;
    }

  }  // for (*iterations)
  
  if ( (error > 4*min_error && error > 1e-4 && (*iterations) > 99)
    || (error > 10 && (*iterations) > 10) ) status=1; // divergence?


  if ((*iterations) >= maximumNumIterations) {
    if (!myid && Control.output>1) 
       printf("directIteration Error: iterations>=maximumNumIterations\n"); // exit
    status=-6;
#if EXIT_ON_ERROR
        ERR("no convergence");
#endif
  }

  free_dvector(lhs,0,numConfigs+5);
  free_dvector(rhs,0,numConfigs+5);
  free_dvector(tmp,0,numConfigs+5);

  return status;
}

// in:  x[NumConf]  nc=mnewt.n=NumberConfigurations
// out: fvec[1..nc], fjac[1..nc][1..nc] but need fjac[1..nc][0] as dummy space
// called by mnewt()=NewtonRawson in num_methods.C (ntrial) times
void usrfun(int nc, double *fvec, double **fjac, double *x, int iterations)
{  
  int i, k, bonds;
  int idx[7]={0,0,0,0,0,0,0};
  double dummy;
  double xi2, xi3, xi4, xi5, multiplier;

  if (Control.output > 3 && myid == 0) {
    printf("DBG4: usrfun inp.x[]=");    
    for (i=1; i<=nc && i<=6; i++) printf(" % 10.8f", x[i]);
    if (nc>6) printf(" ...");
    printf("\n");
  }

  if (sizeof(int *)<=4 && nc>=16384-1){
    /* may be the 2D-array is to big for a 32bit-system (nC>=(2GB/8)^.5) */
    if (!myid)
      printf("ERROR usrfun: array to big for a 32bit-system\n");
    ERR("ERROR 32bit double array range overflow");
  }
  // JS 2011-03-10 replace NumberConfigurations by nc
  //   use fjac[i][0] for dummy operations (faster than if)
  for(i=1;i<=nc;i++) {    
    fvec[i]=0.0;
    // 2011-03-10 use fjac[1..nc][0] for dummy operations
    for(k=0;k<=nc;k++) fjac[i][k]=0.0;  /* may fail if nC*nC*double>2GB */
  }  
  
  term_rewind(1);
 
  x[0]=1.0; /* obsolete??? Joerg Sep05 */
  i=0;
  for(bonds=1;bonds<=Params.bonds;bonds++) {

    for(;;i++) {
      
       // ToDo: call function term_eq(in:x,in:maxex,id=3,out:newex) ???
       // newex[i0]+=terms(x)*maxex[i2]; ???
      term_get(1,idx,&dummy);
      if (idx[1]==STOP_TERM) break;
      
// #if DEBUG // keep code small for CPU Icache
      if ((idx[0] <= 0 || idx[0] > nc)
       || (idx[2] <  0 || idx[2] > nc)
       || (idx[3] <  0 || idx[3] > nc)
       || (idx[4] <  0 || idx[4] > nc)
       || (idx[5] <  0 || idx[5] > nc)) ERR("bad index");
// #endif
      
      xi2=x[idx[2]];
      xi3=x[idx[3]];
      xi4=x[idx[4]];
      xi5=x[idx[5]]; 

      multiplier = delta[bonds][idx[1]]*dummy;
       
      fvec[idx[0]] += xi2*xi3*xi4*xi5*multiplier;
     
      // 2011-03-10 use dummy operations, less code, more space (faster!) 
      /*if (idx[2]>0)*/ fjac[idx[0]][idx[2]]+= xi3*xi4*xi5*multiplier;
      /*if (idx[3]>0)*/ fjac[idx[0]][idx[3]]+= xi2*xi4*xi5*multiplier;
      /*if (idx[4]>0)*/ fjac[idx[0]][idx[4]]+= xi2*xi3*xi5*multiplier;
      /*if (idx[5]>0)*/ fjac[idx[0]][idx[5]]+= xi2*xi3*xi4*multiplier;
       
    }
  }

  if (Control.output > 4 && myid == 0) {
    printf("DBG5: usrfun (read %d):\n",i);
    for (i=1; i<=nc; i++) {
      if (i==6 && nc>10) printf (" ...\n");
      if (i>5 && i<nc-4) continue;
      for (k=1; k<=nc; k++) {
        if (k<=5 || k>nc-5) printf(" % 10.8f",fjac[i][k]);
        if (k==6 && nc >10) printf (" ...");
      }
      printf(" : % 10.8f \n",fvec[i]);
    }
  }
  
}

/*****************************************************
 *                                                   *
 * Obtain bra state (LU decomp.)                     *
 *                                                   *
 *****************************************************
 *                                                   *
 * x_I        -- ket-state correlatin coefficient.   *
 * \tilde x_I -- bra-state correlatin coefficient.   *
 *                                                   *
 * H = e_0 + sum_I \tilde x_I F_I                    *
 *                                                   *
 *****************************************************
 *                                                   *
 * d H / d (\tilde x_I) =>                           *
 *                                                   *
 * F_I = 0    <= ket-state equations                 *
 *                                                   *
 *****************************************************
 *                                                   *
 * d H / d x_I =>                                    *
 *                                                   *
 * d(e_o)/d(x_I)+sum_J \tilde x_J (d(F_J)/d(x_I)) =0 * 
 *            <= bra-state equations                 *
 *                                                   *
 * use LU decomposition to solve the equations:      *
 *                                                   *
 * F(I,J) (\tilde X(J)) = - e_o(I)                   *
 *                                                   *
 *****************************************************/

void findBraState(double *x, double *bra_x)  // NR only
{

  /* Determines the bra-state correlation coefficients
     using LU decomposition.
     */

  int      i;
//  int      status;
  void     lubksb(double **a, int n, int *indx, double b[]);
  void     ludcmp(double **a, int n, int *indx, double *d);
  int      *ind;
  double   d;
  double   **bra_eqn;
  // int      length;
  // int      iterations;

  for(i=1;i<=NumberConfigurations;i++) 
    bra_x[i]=0.0; 

  ind=ivector(0,NumberConfigurations+1);
  bra_eqn=dmatrix(0,NumberConfigurations+1,0,NumberConfigurations+1);
  if (!bra_eqn) { ERR("NR.findBraState.dmatrix, try DI!\n"); }

  findBraStateRHS(bra_x,x); // bra_x (-=) GSEterms(x)
  
  // find sum_J \tilde x_J (d(F_J)/d(x_I)) == F(I,J)
  
  findBraEquations(bra_eqn, x);
  
  // LU decomp Numerical Recipes to solve: F(I,J) (\tilde X(J)) = - e_o(I)
  
  ludcmp(bra_eqn,NumberConfigurations,ind,&d);
  lubksb(bra_eqn,NumberConfigurations,ind,bra_x);
  
  free_ivector(ind,0,NumberConfigurations+1);
  free_dmatrix(bra_eqn,0,NumberConfigurations+1,0,NumberConfigurations+1);

}
  

/*****************************************************
 *                                                   *
 * Obtain bra state (direct iteration)               *
 *                                                   *
 *****************************************************
 *                                                   *
 * x_I        -- ket-state correlatin coefficient.   *
 * \tilde x_I -- bra-state correlatin coefficient.   *
 *                                                   *
 * H = e_0 + sum_I \tilde x_I F_I                    *
 *                                                   *
 *****************************************************
 *                                                   *
 * d H / d (\tilde x_I) =>                           *
 *                                                   *
 * F_I = 0    <= ket-state equations                 *
 *                                                   *
 *****************************************************
 *                                                   *
 * d H / d x_I =>                                    *
 *                                                   *
 * d(e_o)/d(x_I)+sum_J \tilde x_J (d(F_J)/d(x_I)) =0 * 
 *            <= bra-state equations                 *
 *                                                   *
 * Use direct iteration to solve:                    *
 *                                                   *
 *    (\tilde X(I)) = { - e_o(I) - \sum_{J != I}     *
 *                F(I,J) (\tilde X(J))}/F(I,I)       *
 *                                                   *
 * for the \tilde X(I)'s.                            *
 *                                                   *
 *****************************************************/

int directIterationBraState(int maximumNumIterations, int numConfigs, 
			    double tolerance, int *iterations, 
			    double *oldX, double *oldBraX)
{

  double error, min_error, mom;
  
  int i, j, bonds, max_bra_i=1;
  int idx[7]={0};
  double dummy[1]={0.0};
  double xi2, xi3, xi4, xi5,multiplier;
//  double tempSum1, sum1,tempSum2, sum2;
  double subLatticeMag[MAX_UNIT_CELL+1] = {0.0, 0.0};

  double *lhs, *rhs;
#if (PARALLEL_FLAG> 0)
  double *tempLHS, *tempRHS;
  tempLHS=dvector(0,numConfigs-1);
  tempRHS=dvector(0,numConfigs-1); // nrutil.dvector(nl,nh)=malloc(nh+1)
#endif
  
  error = 0.0;
  min_error= 10.0;
  mom = momentum;
  // mom = 0.7;  // 0.25
  if (myid == 0) printf("Direct iteration bra state (mom=%g):\n",mom);

  lhs=dvector(0,numConfigs+1); // +1 is for safety, not needed
  rhs=dvector(0,numConfigs+1);

  for(i=1;i<=numConfigs;i++) {
    lhs[i]=0.0;
    rhs[i]=0.0;
  }

#if 0
  // oldX[0]=1.0; 
  // JS 2011-03-10 added for triang-3-4 np=8++
  if (Control.output > 4 && myid <= 4) {
    for (i=0;i<9 && i<=numConfigs;i++)
      printf("DBG5 %2d: oldx[%d]=%11.4e\n",myid,i,oldX[i]);
  }
#endif
//#if (PARALLEL_FLAG != 0)     // JS 2011-03-10 added for triang-3-4 np=8++
//  findBraStateRHS(rhs,oldX); // rhs (-=) GSEterms(oldX)
//#endif


  for((*iterations)=1;(*iterations)<=maximumNumIterations;(*iterations)++) {
        
#if (PARALLEL_FLAG == 0) 
    findBraStateRHS(rhs,oldX); // rhs (-=) GSEterms(oldX)
#endif

    term_rewind(1);  // .terms

    for(bonds=1;bonds<=Params.bonds;bonds++) {
      
      for(i=1;;i++) {
	
       // ToDo: call function term_eq(in:x,in:maxex,id=3,out:newex) ???
       // newex[i0]+=terms(x)*maxex[i2]; ???
        term_get(1,idx,dummy);
        if (idx[1]==STOP_TERM) break;

#if DEBUG // keep code small for CPU Icache
      if ((idx[0] <= 0 || idx[0] > NumberConfigurations)
       || (idx[2] <  0 || idx[2] > NumberConfigurations)) ERR("bad index");
#endif

        multiplier = dummy[0] * delta[bonds][idx[1]];
	
	if (idx[2]==0) { // all indices are equal to 0
	  
	  // rhs[idx[0]]+=multiplier;
	  
	} else {
	  
          oldX[0]=1.0;
	  xi2=oldX[idx[2]];
	  xi3=oldX[idx[3]];
	  xi4=oldX[idx[4]];
	  xi5=oldX[idx[5]];  /* only for term34 */

          if (idx[5]>0) rhs[idx[5]]-=xi2*xi3*xi4*multiplier*oldBraX[idx[0]];
          if (idx[4]>0) rhs[idx[4]]-=xi2*xi3*xi5*multiplier*oldBraX[idx[0]];
          if (idx[3]>0) rhs[idx[3]]-=xi2*xi4*xi5*multiplier*oldBraX[idx[0]];
	  if (idx[2]>0) {
	    if (idx[2]==idx[0]  && idx[3] ==0) // [4..5] == 0 too
	          lhs[idx[0]]+=xi3*xi4*xi5*multiplier;
	    else  rhs[idx[2]]-=xi3*xi4*xi5*multiplier*oldBraX[idx[0]];
	  }
	}
      }
    }
      
#if (PARALLEL_FLAG> 0)
    /* ToDo JS06: speedup if rhs/lhs or only error[npe] summed,
     *    changing oldX can be distributed over threads */
    MPI_Allreduce(lhs+1, tempLHS, numConfigs, 
		  MPI_DOUBLE, MPI_SUM,MPI_COMM_WORLD);
    MPI_Allreduce(rhs+1, tempRHS, numConfigs, 
		  MPI_DOUBLE, MPI_SUM,MPI_COMM_WORLD);
    for(i=1;i<=numConfigs;i++) {
      lhs[i]=tempLHS[i-1];
      rhs[i]=tempRHS[i-1];
    }
    findBraStateRHS(rhs,oldX);  // rhs (-=) GSEterms(oldX)
#endif

    error=0.0;
    for(j=1;j<=numConfigs;j++) {
      if (fabs(lhs[j]) < 1e-9) {
	printf("Error in direct iterations bra state: no left-hand side...\n"
          "it= %4d  cfg= %4d  rhs= % .4e lhs= % .4e < 1e-9 ---  Exiting!!\n",
           *iterations, j, rhs[j], lhs[j]);
	break;
      }
      error+=fabs(oldBraX[j]-rhs[j]/lhs[j]);
    }
    if (j<=numConfigs) break;
#if 0  // can generate lot of iterations
    if (error>8*min_error) { // New JS Apr06, 2* => 8* Mar08, ToDo: make bigger?
       mom = 1.0 - 0.5*(1.0 - mom);  /* 1-0.3 -> 1-0.15 -> 1-0.075 -> ... */
       min_error = error;
       if (!myid)
         printf(" It=%d: reduce 1-momentum to %g to ensure convergence\n",
                *iterations, 1.0-mom);
       if (1.0-mom<1e-6) break;
    }
#endif
    for(j=1;j<=numConfigs;j++) {
      oldBraX[j]=mom*oldBraX[j]+(1.0-mom)*rhs[j]/lhs[j];
      if (fabs(oldBraX[max_bra_i])
         <fabs(oldBraX[        j])) max_bra_i=j;
      lhs[j]=0.0;
      rhs[j]=0.0;
    }

    if (Control.output > 0 && myid == 0
       && ((((*iterations) % 20)==0 || Control.output > 2)
       || error < tolerance
       || error > min_error)) // Jan2010 output growing error
      printf(" %5d mag   %14.12f err %8.1e %8.1e bra_max %4d %11.8f\n",
	*iterations, findStagMag(oldX,oldBraX,subLatticeMag),
        error, error-min_error, max_bra_i, oldBraX[max_bra_i]);

    if (error < min_error) min_error = error;
    if (error < tolerance) break;
    // NaN happens for j1-j2-neel j2>0.55 ??? was a bug (Mar09 fixed)?
    if ((isnan(subLatticeMag[1]) || isnan(error))) {
      static int err_nan=0;
      if (++err_nan<10 && myid<10)
        printf("NaN-Error: SublMag= %g err= %g myid= %d (max=9)\n",
          subLatticeMag[1], error, myid);
      if (isnan(error)) ERR("error=NaN");
    }
    if (error > 1e6) { // divergence
      subLatticeMag[1]=0; // set flag!
      (*iterations)=-abs(*iterations)-1; break;
    }

  }

  if ((*iterations) >= maximumNumIterations) {
    printf("directIterationBraState Error: i>=maximumNumIterations\n");
    if (error>1e-6) subLatticeMag[0]=0; // JS-Jan10 dont exit
    // ToDo: set bra[i]=0 as signal for bad convergence? JS-Jan10
  }

  free_dvector(lhs,0,numConfigs+5);
  free_dvector(rhs,0,numConfigs+5);
#if (PARALLEL_FLAG> 0)
  free_dvector(tempLHS,0,numConfigs-1);
  free_dvector(tempRHS,0,numConfigs-1);    
#endif

  return *iterations;
}

// input:  rhs, x (global: terms, Params.bonds, NumberConfigurations)
// output: rhs    ( -= GSEterms(x) ) 
// --- called from each thread ---
void findBraStateRHS(double *rhs, double *x) 
{
  int i, bonds;
  int idx[7]={0};
  double dummy[1];
  double xi2, xi3, xi4, xi5, multiplier;

       // ToDo: call function term_eq(in:x,in:maxex,id=3,out:newex) ???
       // newex[i0]+=terms(x)*maxex[i2]; ???
  term_rewind(0);

  for(bonds=1;bonds<=Params.bonds;bonds++) {

    for(i=1;;i++) {
      
      term_get(0,idx,dummy); // GSE  idx[0]=0 always
      if (idx[1]==STOP_TERM) break;

#if DEBUG // keep code small for CPU Icache
      if (idx[2] <  0 || idx[2] > NumberConfigurations) ERR("bad index");
#endif
      
      multiplier=delta[bonds][idx[1]];

      // ToDo: how often? can be removed?
      if ((idx[2]==0 && idx[3]==0
        && idx[4]==0 && idx[5]==0)) continue;
	
      x[0]=1;
      xi2=x[idx[2]];
      xi3=x[idx[3]];
      xi4=x[idx[4]];
      xi5=x[idx[5]];
      // ToDo: faster if using dummy rhs[0] ???
      if (idx[2] > 0) rhs[idx[2]]-= dummy[0]*xi3*xi4*xi5*multiplier;
      if (idx[3] > 0) rhs[idx[3]]-= dummy[0]*xi2*xi4*xi5*multiplier;
      if (idx[4] > 0) rhs[idx[4]]-= dummy[0]*xi2*xi3*xi5*multiplier;
      if (idx[5] > 0) rhs[idx[5]]-= dummy[0]*xi2*xi3*xi4*multiplier;
    }
  }
}

// ToDo: m-indizes are cache unfriendly, change it! JS091107
// work: m[0][x]
// out: m[1..NumCfgs][1..NumCfgs]
// ToDo: melt with usrfun?
void findBraEquations(double **m, double *x) 
{
  /* FIND BRA EQUATIONS: finds the Jacobian in order to determine 
   the bra state equations.
   */

  // find: sum_J \tilde x_J (d(F_J)/d(x_I))
  
  int i,k,bonds;
  int idx[7]={0};
  double dummy[1];
  double xi2, xi3, xi4, xi5, multiplier;
  
  term_rewind(1);
  
  for(i=1;i<=NumberConfigurations;i++)    
    for(k=1;k<=NumberConfigurations;k++) 
      m[i][k]=0.0;

  for(bonds=1;bonds<=Params.bonds;bonds++) {
    
    for(i=1;;i++) {
      
      term_get(1,idx,dummy); // .terms
      if (idx[1]==STOP_TERM) break;

#if DEBUG // keep code small for CPU Icache
      if ((idx[0] <= 0 || idx[0] > NumberConfigurations)
       || (idx[2] <  0 || idx[2] > NumberConfigurations)) ERR("bad index");
#endif
      
      multiplier=dummy[0]*delta[bonds][idx[1]];

      // check that one of idx[2..5] is not zero 
      if (idx[2]==0) continue; // rarely!? dont needed 
      
      x[0]=1.0;  // dummy factor 1 does not change anything
      xi2=x[idx[2]];
      xi3=x[idx[3]];
      xi4=x[idx[4]];
      xi5=x[idx[5]];
      // ToDo: faster using dummy roe+column 0 (m[0][x],m[x][0]) ???
      if (idx[2] > 0) m[idx[2]][idx[0]]+= xi3*xi4*xi5*multiplier;
      if (idx[3] > 0) m[idx[3]][idx[0]]+= xi2*xi4*xi5*multiplier;
      if (idx[4] > 0) m[idx[4]][idx[0]]+= xi2*xi3*xi5*multiplier;
      if (idx[5] > 0) m[idx[5]][idx[0]]+= xi2*xi3*xi4*multiplier;
    }
  }
}

/*****************************************************
 *                                                   *
 * Name: Staggered Magnetisation Routine.            *
 *                                                   *
 * Determines the lattice magnetisation once bra-    *
 * and ket-state equations have been solved.         *
 *****************************************************/

double findStagMag(double *x, double *bra_x, double *subLatticeMag)
{
  /* FIND STAG MAG: obtains the staggered magnetisation. */
  int      i, j;
  double   stagMag;
  int      length;
  int      (*configuration)[5];
  int      subTerm[MAX_UNIT_CELL+1];

  configuration = (int (*)[5]) malloc( (MAX_SUBN+1)*5*sizeof(int) );
  if (!configuration) { printf("ERROR findStagMag: malloc\n"); return 0; }
  /* ToDo JS0911: how to handle error in MPI case? */

  // first find the \sum_i < \tilde \Psi | s_i^z | \Psi > bit.

  stagMag=0.0; 
  
  for(i=1;i<=UnitCell.number;i++) {
    subLatticeMag[i] = 0.5*UnitCell.s2[i];
    stagMag         += 0.5*UnitCell.s2[i];
  }
  
  stagMag=stagMag/((double) UnitCell.number);

  for(i=1;i<=NumberConfigurations;i++) {

    length=findClusterFromDescriptor(spinConfigurations[i].descriptor,
				     configuration);

    stagMag -= length*bra_x[i]*x[i];    
    sublattice_term(length,configuration,subTerm);
    
    for(j=1;j<=UnitCell.number;j++) 
      subLatticeMag[j] -= subTerm[j] * bra_x[i] * x[i]
                        * UnitCell.number / LatticeSymmetries.number;
  }

  free(configuration);
  return stagMag;
}

void sublattice_term(int length, int (*configuration)[5], int *subTerm)
{
  
  /* 
     This routine finds contribution to the sublattice magnetisation
     from a given cluster, namely:
     
     F(m) . S(+)(m) 
  */
  int i, j;
  static int tempConfiguration[MAX_SUBN+1][5]={{0,0,0,0,0}};
    // ={...} against tcc-0.9.25 bug
  
  for(i=1;i<=UnitCell.number;i++) subTerm[i]=0;

  // find symmetry related clusters
  for(j=0;j<LatticeSymmetries.number;j++) {  // JS1003: 0.. old=1..
    /* ToDo: configuration modified ?? */
    symmetryGroup(j,length,configuration,tempConfiguration);
    for(i=1;i<=length;i++) { subTerm[tempConfiguration[i][4]]++; }
  } 

  return;
}

// new code to find the generalised expectation values.

void findGenExp(double *x, double *bra_x, double *g_exp, double *alpha)
{

  /* FIND GENERALISED EXPECTATION VALUES: obtains the staggered magnetisation.
     */

  int      i,j,index,term,offs;
 // int      (*configuration)[5];  // removed JS1002
  int      expect,error;
  int	   idx[7]={0};
  double   dummy[1],multiplier;
  double   xi2, xi3, xi4, xi5,bx;

//  configuration = (int (*)[5]) malloc( (MAX_SUBN+1)*5*sizeof(int) );
//  if (!configuration) { printf("ERROR findStagMag: malloc\n"); exit(1); }
  /* ToDo JS0911: how to handle error in MPI case? */
    
  // JS0902: for parallel, we store GSE terms temporary 
  // g_exp[1..nExpect] final result, g_exp[nExpect+2..2*nExpect] GSE terms
  for(i=0;i<=2*Params.nExpect;i++) g_exp[i]=0.0;

       // ToDo: call function term_eq(in:x,in:maxex,id=3,out:newex) ???
       // newex[i0]+=terms(x)*maxex[i2]; ???
  term_rewind(2); // term_open(2,"r"); Jun08

  for(expect=1;expect<=Params.nExpect;expect++) {

    for (j=1;j<=2;j++) { // GSE terms + hh terms
      for(i=1;;i++) {  // sum all terms

        error=term_get(2,idx,dummy); /* .exp_terms */
        if (idx[1]==STOP_TERM) break;

#if DEBUG // keep code small for CPU Icache
      if ((idx[0] <= 0 || idx[0] > NumberConfigurations)
       || (idx[2] <  0 || idx[2] > NumberConfigurations)) ERR("bad index");
#endif

        index=idx[0];
        // the index for the bra-state correlation coefficient.
	// if this is zero then it's one of the "gs" like terms.
	
        // ToDo: use bra_x[0]=1.0
	term=idx[1];
	bx=bra_x[index];
	if (index < 1) bx=1.0;
	
	xi2=x[idx[2]];
	xi3=x[idx[3]];
	xi4=x[idx[4]];
	xi5=x[idx[5]];

        multiplier=1.0;

#if UseExpAlpha
         // arg2 is term13 (range=1..13) 2008-10-01
        // DJJF0902: usr_exp_angle can be different from usr_angle
        //           exsample: lattice magnetization of triangular lattice
        multiplier=usr_exp_angle(expect,map62[term],alpha,UseAlpha);
	// bad: multiplier=usr_exp_angle(expect,term,alpha,UseAlpha);
#endif
			
#if DEBUG // keep code small for CPU Icache
	if (Control.output > 3 && myid ==0) 
	  printf("expect=%d : config=%d : term =%d : (%d,%d,%d,%d) : mult1=%10.6f : mult2=%10.6f : g_exp=%10.6f\n",
	         expect,idx[0],idx[1],idx[2],idx[3],idx[4],idx[5],
		 dummy[0],multiplier,g_exp[expect]);
#endif

        g_exp[expect] += bx*xi2*xi3*xi4*xi5*dummy[0]*multiplier;
			
      } // i=1...
      if (j==1) { // GSE
        offs=Params.nExpect;
        g_exp[offs+expect]=g_exp[expect];
        g_exp[     expect]=0.0;
      }
    } // j=1..2

  } // expect=1..nExpect
#if (PARALLEL_FLAG> 0)
  {  int j;
     double *tmp_exp=(double *)malloc((Params.nExpect+1)*sizeof(double));
     if (!tmp_exp) MPI_Abort(MPI_COMM_WORLD, 1);
     for(j=1;j<=Params.nExpect;j++) tmp_exp[j]=g_exp[j];
     MPI_Allreduce(&tmp_exp[1], &g_exp[1], Params.nExpect,
                     MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
     free(tmp_exp);
  }
#endif
  for(j=1;j<=Params.nExpect;j++) g_exp[j]+=g_exp[Params.nExpect+j];

  // fclose(fp_exp); Jun08
//  free(configuration);
  return;
}

// DJJF Jun08: new code to find the excitation energy values.
// Joerg: add MPI functionality

void findExcitations(double *x, double *bra_x, double *alpha, double *ee)
{

  /* Find the lowest lying excitation energies (ee) from the CCM excited-state equations.

     Solved as an eigenvalue problem using the eispack routine rg_().
	 
	 Written by Damian JJ Farnell: 27 June 2008. 
	 
	 Copyright: Damian JJ Farnell (June 2008). All rights reserved.
     */

  int      i,j,index,term,bonds; // unused? ,k;
  int      term_get_error;
  int	   idx[6]={0,0,0,0,0,0};
  int      nex = NumberExcitedConfigurations; // abbreviation
  double   dummy[1];
  double   xi3, xi4, xi5;
  double   multiplier1; // ,multiplier2;

  // - - - full diagonalization of Excitat State Matrix - - -
  if (solutionStrategy==1) { // Newton-Raphson(?) (serial, but nC^2 memory)
    // new code written 19 December 08 DJJF
    //  strategy=2 - direct iteration excited-state CCM (parallel)

    // now open the excitations CCM equations file.
    // newex[i0]+=terms(x)*maxex[i2]; ???
    term_rewind(3);	// .exc_terms
      
    // find the initial v
      
    static double *m=NULL;  // matrix
    // if (nex > 1) 
    // Joerg Jun08: needs much memory cfg^2, ToDo: split into threads!
    {
      if (!m) // malloc once, never free
      m=dvector(0,(nex)*(nex));
      if (!m)
       { printf("ERROR: ecs_matrix=malloc(dbl*numExcCfg^2)\n"); return; }
      for (i=0;i<nex*nex;i++) m[i]=0.0;
    }
    *ee=0.0;
      
    for(bonds=1;bonds<=Params.bonds;bonds++) {
      for(i=1;;i++) {
        term_get_error=term_get(3,idx,dummy); // .exc_terms
        if (idx[1]==STOP_TERM) break;
#if DEBUG // keep code small for CPU Icache
        if ((idx[0] <= 0 || idx[0] > nex)
         || (idx[2] <  0 || idx[2] > nex)) ERR("bad index");
#endif
        x[0]=1.0;         // JS0902: speed trick, replacing if constructs
        index=idx[0]; // the index for the excited correlation coefficient.
                          // This is never zero for excited states	
        term =idx[1]; // term number (1..81) in the excited-state eq.
        xi3=x[idx[3]];    // a CCM correlation coefficient
        xi4=x[idx[4]];    // a CCM correlation coefficient
        xi5=x[idx[5]];    // a CCM correlation coefficient
                            
        // term2=mapping[term];  // map 1..81 => 1..62 [ => 1..13]
        // Joerg Jun08: mapping done in obtainExc... now
        // term2=term;
        multiplier1 = delta81[bonds][term]; // usr_angle included
        {
          // x[2] <- excitation coefficients
          // x[3] to x[5] <= g-s ket-state coefficients (NO PARTICULAR ORDER)
          index=(idx[0]-1)*nex + idx[2]-1;
          m[index] += xi3*xi4*xi5*dummy[0]*multiplier1;
        }
#if DEBUG
        if (Control.output > 2 && !myid) 
          printf("Bond %d cfg %d t%02d.%02d : %d %d %d %d m1=%10.6f m2=%10.6f tot=%10.6f\n",
              bonds, idx[0], map81[idx[1]], idx[1], idx[2],
              idx[3], idx[4], idx[5],
              dummy[0], multiplier1, xi3*xi4*xi5*dummy[0]*multiplier1);
#endif
      }
    }
    // fclose(fp_exc);

#if (PARALLEL_FLAG> 0)
    // if (nex > 1) 
    {
      static double *m2=NULL; // int nex=nex;
      if (!m2) m2=dvector(0, nex*nex); // exit on error
      for (i=0;i<nex*nex;i++) m2[i]=m[i];
      MPI_Allreduce(m2, m, nex*nex, MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
      free_dvector(m2,0,nex*nex); m2=NULL;
      // now we can use single-task algorithm to go further
    }
#endif

    // non-parallel
    // order1=(long) nex; => excMatrixSize
    *ee=m[0];
    if (nex>1) {  // else *ee=m[0];

      int imin=0, iminr=0, imax=0;
      double *wi,*wr,*z,*fv1;
      long int *iv1;

      // ToDo: Jun08, alpha version had a memory leak!
      wi =dvector(0,(nex)); 
      wr =dvector(0,(nex)); 
      iv1=(int long *)malloc(2*nex*sizeof(long int));
      if (!iv1) ERR("malloc iv1[2*NumExcCfgs*long]");
      fv1=dvector(0,(2*nex)); 
      z  =dvector(0,(2*nex)); // JS1002: not used!
     
      long int order1=0;
      long int   matz=0;
      long int   ierr=0;
      int stat;

      order1=(long) nex;

  // DJJF test: matrix LSUB4 Heisenberg square from old CCM code
  // Joerg: hmm, I have other results for LSUB4 Heisenberg square
#if 0
  // 6*6 matrix:
  { int i; double m_sample[6*6] =
#if 0 // old
{  1.1216377,-12.0000000,-12.0000000,-24.0000000,-24.0000000,-24.0000000,
  -0.0481599,  4.9819834,  0.1306343, -0.0457941, -0.0915882, -0.0330296,
   0.0048209,  0.0754497,  5.9845166, -0.0063823, -0.0521764, -0.3502249,
  -0.0376121, -0.0228971, -0.0165148,  5.2698994, -0.3667397, -0.1017208,
   0.0043092, -0.0000000, -0.0197059, -0.1604728,  5.9629355, -0.1948184,
   0.0089379,  0.0031911, -0.1751124, -0.0050663, -0.1948184,  5.8779124};
 // old v0807, accuracy %.7f minEx=0.85186729 (1e-6) DJJF
 //                          Ex1=  5.04809232
 //                          Ex2-3=5.50276245 + i *  0.12031869
 //                          Ex4=  6.05399996
 //                          maxEx=6.23940053
#else // ToDo: matrix changed, but same eigenvalues!!!? (sorted GS-vec???)
{  1.1216377, -2.0000000, -2.0000000, -4.0000000, -4.0000000, -4.0000000,
  -0.2889593,  4.9819834,  0.1306343, -0.0457941, -0.0915882, -0.0330296,
   0.0289254,  0.0754497,  5.9845166, -0.0063823, -0.0521764, -0.3502249,
  -0.2256725, -0.0228971, -0.0165148,  5.2698994, -0.3667397, -0.1017208,
   0.0258552,  0.0000000, -0.0197059, -0.1604728,  5.9629355, -0.1948184,
   0.0536276,  0.0031911, -0.1751124, -0.0050663, -0.1948184,  5.8779124};
   // Mai2010 %.7f minEV= 0.851867585843 (accuracy=1e-7) nC=7+6 
  // JS:                  0.851867601151 !!! (see papers)
  // JS:           ExMin= 0.851867600611 (1e-10) 2010-04-20
  //               ExMax= 6.239400533501 restr=3
  //               ExMax= 6.496533096261 restr=2 (decoupled from rest!)
  //               ExMax= 7.102943742197 restr=1
  // boundaries? trace=SumEV=const?
  // nonNeg-diag-elements? minDiagElem / maxDiagElem
  // J2=0   2 complex eigenvalues (same real part)
  // J2=0.24 all eigenvalues real and different
  // J2=0.62 maxEx(J2)=min
  // J2=0.68 E0(J2)=max
  // J2=0.76 negMag
  // J2=0.92 2 complex eigenvalues (same real part)
  // J2=0.95 neg.GAP
#endif
    for (i=0;i<6*6;i++) m[i]=m_sample[i];
  }
#endif

      if (!myid)
      if ((Control.output>2 && order1<13) || Control.output>3) {
        printf("\nCCM Excited-State Eigenvalue Matrix To Be Diagonalised =\n");
        for (i=0; i<order1; i++) {    
          for (j=0; j<order1; j++) {
            if (order1<6)  printf(" % 11.9f",m[i*nex+j]);
            else {
              if (order1<8) printf(" % 9.7f",m[i*nex+j]);
              else          printf(" % 8.6f",m[i*nex+j]);
            }
          }
          printf("\n");
        }
        printf("\n");
      }
 
      // eispack eigenvalue routine, find eigenvalues + vectors(?) of
      //   real general matrix
      // input:  1=rows 2=order m=matrix matz=0L(noEV)
      stat=rg_(&order1 , &order1 , m ,wr , wi, &matz, z, iv1, fv1, &ierr);
      // output: wr+wi real+imag of eigenvalues, z=vectors, ierr:0=OK
      // work: iv1, fv1
                  
      if (ierr !=0) 
        printf("Ierror in solve excitations = %d\n",(int) ierr);
     
      *ee=1e10; // ee contains the lowest-valued eigenvalue
      for (i=0; i<order1; i++) {
        if (Control.output > 0 && myid==0 && i<(1<<(2*Control.output))) {
          printf("Excited-state Eigenvalue %2d = ( %16.12f , %16.12f ) \n",
                 i+1, wr[i], wi[i]);
        }
        // ToDo: min. absolut or min reel
        if (fabs(wi[i])<1e-6)               // skip complex values
        if (wr[i] < wr[imin ]) { imin= i; }
        if (wr[i] < wr[iminr]) { iminr=i; } // include complex values
        if (wr[i] > wr[imax ]) { imax= i; }
      }
      *ee = wr[imin];
      if (myid==0 && Control.output>0) {
        printf("Min Excited-state Eigenvalue %3d = ( %16.12f , %16.12f )\n",
               imin, wr[imin], wi[imin]);
        if (imin!=iminr)
        printf("Min Excited-state Eigenval.? %3d = ( %16.12f , %16.12f )\n",
               iminr, wr[iminr], wi[iminr]);
        printf("Max Excited-state Eigenvalue %3d = ( %16.12f , %16.12f )\n",
               imax, wr[imax], wi[imax]);
        if (fabs(wi[iminr])>1e-6) printf("Warning: complex minGAP\n");
      }
      free_dvector(wi, 0,(nex));
      free_dvector(wr, 0,(nex));
      free(iv1);
      free_dvector(fv1,0,(2*nex));
      free_dvector(z,  0,(2*nex));
    } // nex>1

  } else {  // solutionStrategy != 1

    //  - - - direct iteration excited-state (parallel) - - -

    // new code written 19 December 08 DJJF
    //  - direct iteration excited-state CCM
    // shifted power method, see http://en.wikipedia.org/wiki/Power_iteration
    //  power iteration finds the greatest absolute value
    //  multiply vector by matrix and normalize
    //  Problem: when largest value is not much greater than the 2nd?
    //  sparse matrix? 
    // this should "track" the maximum and minimum eigenvalue solution

    double *newex, error, min_error=1e10, norm2;
    double newee=1.0; // JS08: was uninitialized
    int maximumNumIterations, iterations, step;
    double eshift=0.0; // maxee=0.0; // 12.07; // JS091106 empirical
    time_t t0, t1; /* measure time in seconds */
   
    newex=dvector(0,(nex));  /* len=NumEx+1 */
    if (!newex) { printf("ERROR newex malloc\n"); exit(1); }
    maximumNumIterations=(int) MAX_NUM_ITERATIONS;
    //	maximumNumIterations=50000;
#if (PARALLEL_FLAG> 0) 
    static double *m2=NULL;
    if (!m2) m2=dvector(0,nex); /* 0..NumEx */
#endif
    // added by JS 2009-07: maxex[2] is growing endless for xxzTriangle LSUB2 ???
    // for(i=1;i<=nex;i++)  { ex[i]=0.01; maxex[i]=0.01; }

    // first find the maximum (absolute) eigenvalue by power method
    if (Control.output>0 && !myid) 
      printf("Direct It. to max. abs. eigenvalue of exc. state matrix:\n");
  
    time(&t0);
    *ee=1.0e10;

    // first get the maximum, than get the minimum as maximum of shifted M
    for (step=0; step<2; step++) { // JS100527 new, code reduction
      if (step==1) eshift=*ee;      
      if (Control.output>0 && !myid) 
        printf("Direct Iteration step %d, eshift= %.6f\n", step+1, eshift);
      norm2=1/sqrt(1.0*nex);
      for(j=1;j<=nex;j++) maxex[j]=norm2;  // JS 2010-05-27 new: fix startvector
    for(iterations=1; iterations<=maximumNumIterations; iterations++) {
      // ToDo: call function term_eq(in:x,in:maxex,id=3,out:newex) ???
      // newex[i0] = Matrix * maxex[i2]; ???
      term_rewind(3);
      /* Jan09 JS: [0] unused, [1..NumEx] used */
      for(j=1;j<=nex;j++) newex[j]=0.0;
      norm2=0;
      for(j=1;j<=nex;j++) norm2+=maxex[j]*maxex[j];
      norm2=1/sqrt(norm2);
      for(j=1;j<=nex;j++) maxex[j]*=norm2; // JS100527 new
       
      for(bonds=1;bonds<=Params.bonds;bonds++) {
        for(i=1;;i++) {
          term_get_error=term_get(3,idx,dummy); // .exc_terms
          if (idx[1]==STOP_TERM) break;
         
#if DEBUG // keep code small for CPU Icache
          if ((idx[0] <= 0 || idx[0] > nex)
           || (idx[2] <  0 || idx[2] > nex)) ERR("bad index");
#endif
          index=idx[0]; // index for the excited correlation coeff. 1..nex
          term=idx[1]; // term number (1..81) in the excited-state equations  
          x[0]= 1.0; // avoid if(index[3..5]<1) xi3..5=1.0
          xi3 = x[idx[3]];    // a CCM correlation coefficient
          xi4 = x[idx[4]];    // a CCM correlation coefficient
          xi5 = x[idx[5]];    // a CCM correlation coefficient
          // map82[term];  // map 1..81 => 1..62 [ => 1..13]
          // Joerg Jun08: map82[term82] done in obtainExc... now
          multiplier1 = delta81[bonds][term];
          newex[idx[0]] += xi3*xi4*xi5*dummy[0]*multiplier1*maxex[idx[2]];
        } // end read terms
      }  // end bonds ( newex = Matrix * maxex )
#if (PARALLEL_FLAG> 0) 
      for (i=1;i<=nex;i++) m2[i]=newex[i];
      MPI_Allreduce(m2+1, newex+1, nex, MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
#endif
      // JS091106: eshift was 0 initially and for old code, shift by eshift
      //   subtract maxE, so we can iterate to minE=max(M-maxE)+maxE
      //   problem is that we get max|E|, which may be max(-E), not max(E)
      for(j=1;j<=nex;j++) newex[j]-=eshift*maxex[j];
      // done: newex = (ExcEqMatrix(x)-mshift) * maxex

      // JS 2009-07 the matrix may be diagonal, than first nonzero is not best
      // JS091105: better go around 2 times max/search?
#if 0
      // search first non-zero value
      for(j=1;j<=nex;j++) {
        if (fabs(newex[j])>0.0000001) { newee=newex[j]; break; }
      }
#else
      // double min_e=0
      double xMx=0.0, xx=0.0; // DBG
      newee=0;
      // JS2010: matrix subblocks and zero lines or components could create
      //    problems (ToDo: sample square-4-4 restr=3 vs. restr=2)
      for(j=1;j<=nex;j++) {
        xMx += maxex[j] * newex[j];
        xx  += maxex[j] * maxex[j];
//        if (maxex[j]==0 || newex[j]==0) continue;
//        if (newex[j]>newee) newee=newex[j];  // max. Evalue exc. State
//        if (newex[j]>min_e*maxex[j]) min_e=newex[j]/maxex[j]; // max. factor
      }
#endif
      newee=xMx; // JS100527, this is the power method (de:Potenzmethode)

      //  newee+=eshift;  // shift back energy JS091106 ???
      error=fabs(*ee-(newee+eshift));
      *ee=           (newee+eshift);
      if (min_error > error) min_error = error; // JS 2010-05-27 break earlier

      if (!myid && Control.output > 0) {
        if (Control.output > 2
        || (0==iterations%20 || iterations<10 
                             || iterations>maximumNumIterations-10)
        || (error < ((double) TOLERANCE))
        || (error > min_error)) 
          printf("%4d xx,xMx %9.6f %9.6f G %.10f %.1e %.0e\n",
            iterations, xx, xMx, newee+eshift, error, min_error);
        if (Control.output > 2 && iterations<20) {
          printf(  "   x=");
          for(j=1;j<=nex && j<8;j++) printf(" %9.6f", maxex[j]);
          printf("\n  Mx=");
          for(j=1;j<=nex && j<8;j++) printf(" %9.6f", newex[j]);
          printf("\nMx/x=");
          for(j=1;j<=nex && j<8;j++) printf(" %9.6f", ((maxex[j])?newex[j]/maxex[j]:0.0));
          printf("\n");
        }
      }

      // JS2010: is smoothing an advantage here? ToDo: find samples!
      if (newee) // avoid div 0
      for(j=1;j<=nex;j++)
//        maxex[j]=0.5*newex[j]/newee+0.5*maxex[j]; // new = new/2 + old/2
//        maxex[j]=(1-momentum)*newex[j]/newee+momentum*maxex[j]; // sq8 better?
        maxex[j]=newex[j]/newee;
// sq-4-4 17 It: new = (new/mewee)            better version!?
// sq-4-4 41 It: new = (new/mewee)/2 + old/2  old version (2010-05)

      if (error < ((double)TOLERANCE)) break; // stop iteration loop
      // ToDo: better check last 3 ee for monotonie + error
      if (error > min_error*2 && iterations >= 100)
        { iterations*=-1; /* *ee=0; */ break; } // JS 2010-05-27 early break

#if EXPERIMENTAL & 4
      if (error < 1e-4 &&  eshift==0.0) break; // set new energy shift 
// ToDo: better at iteration=10? or error < 1e-2
#endif

    } // iterations loop
    } // steps
    if (iterations>=maximumNumIterations) { *ee=0; } // not converged

    time(&t1);
    if (!myid)  //                       MinGAP  - MaxGAP (TripletGAP)
      printf("ExcitedState It= %4d  Gap= %12.10f - %12.10f Gap.t[min]= %6.2f\n",
                 iterations, *ee, eshift, (t1-t0)/60.);

    if (iterations>=maximumNumIterations) { // JS 2009-07 we cant trust value if not converged
      if (!myid) printf("WARNING: no convergence, resetting values to 0\n");
      *ee=0;
    }
    free_dvector(newex, 0,nex); // remember to free the memory used.
#if (PARALLEL_FLAG> 0) 
    free_dvector(m2,0,nex); m2=NULL;
#endif
  }  // if (solutionStrategy == 1) ... else ...DI...
  return;
}

#if FIDELITY

/* v DJJF 2 June 2010: New Fidelity Code v */ 
double findFidelity(double *obx, double *ox, double *x,
  double *fidelity2, double *weight){
  /**********************************************************
  *                                                         *
  * DJJF 2 June 2010 -- New Fidelity Code                   *
  *                                                         *
  * works out the fidelity F=<\Psi(a-da)|\Psi(a)> - 1       *
  *                                                         *
  **********************************************************/
  
  /**********************************************************
  *                                                         *
  * updated method: 18 November 2010                        *
  * result goes into fidelity2                              *
  * still keep the old estimate in fidelity1 until new      *
  * code validated.                                         *
  * weight of states that obey rule c_I>=0                  *
  * also calculated                                         *
  *                                                         *
  **********************************************************/
  
  double fidelity;
  int index, length, i;  
  int (*configuration)[5];
  int *permutationfactor;  // JS2010.ToDo: int (32bit 4e9 12!) is a bad choice
  double sum1, sum2, sum3;
  double ci=0.0;
  
  // JS-2010-06.ToDo: MAX_SUBN replace by Params.n ???
  permutationfactor = (int (*)) malloc((MAX_SUBN+1)*sizeof(int));
  if (!permutationfactor) ERR("malloc fidelity"); // added JS-2010-06
  if (!myid && npe>1) printf("WARNING: parallel code not yet supported!\n");

  permutationfactor[1] = 1;
  // JS-2010-06.ToDo: MAX_SUBN replace by Params.n ???
  // JS-2010-06: 16 replaced by MAX_SUBN (13! dont fit to 32bit)
  for (i=1; i<MAX_SUBN; i++) {
    permutationfactor[i+1]=permutationfactor[i]*(i+1);
    // JS-2010-06: handle integer overflow
    if (permutationfactor[i+1]*1.0 != (permutationfactor[i]*1.0)*(i+1)) {
      permutationfactor[i+1]=0; // JS-2010-06: causing div0 or 0 result !?
//      if (!myid) printf("WARNING: integer overflow in findFidelity!\n");
    }
//    printf("Perms: %d %d\n",i,permutationfactor[i]);
  }

  configuration = (int (*)[5]) malloc( (MAX_SUBN+1)*5*sizeof(int) );
  if (!configuration) { printf("ERROR findStagMag: malloc\n"); return 0; }
  
  fidelity=0.0;
  *fidelity2=0.0;
  sum1=0.0;
  sum2=0.0;
  sum3=0.0;
      
  for(index=1;index<=NumberConfigurations;index++) {
    // JS.ToDo: length is used only inside ...Contrib, move there
    length=findClusterFromDescriptor(spinConfigurations[index].descriptor,
				     configuration);
    fidelity += obx[index] * findFidelityContrib(length, configuration,
          index, ox, x, permutationfactor, &ci);

    // JS.2010-11-22 sum1=sum1+=... replaced by sum1+=..., same for sum2..3
    if (ci>=-0.00000000000001)
      sum1+=ci*ci*embedding[index]; // for numerator weight
    sum2+=ci*ci*embedding[index];   // for denominator weight
	
	// need also to introduce a lattice embedding factor nu_I
	
    sum3+=oldC[index]*oldC[index]*embedding[index]; // for fidelity 2
	(*fidelity2)+=ci*oldC[index]*embedding[index];          // for fidelity 2
	oldC[index]=ci;                                      // for fidelity 2

    if (ci<-0.000000000000001 && Control.output>5) {
	  printf("Negative C-I coefficient one... index = %d & value = %20.16f!\n",index,ci);
	}
	  
  }
  
  (*weight)=sum1/sum2;
  
  if (sum3>0.0 && sum2>0.0)
     (*fidelity2)=1.0-(*fidelity2)/sqrt(sum2*sum3);
  else 
     (*fidelity2)=-1.0;
   
 // printf("Weight = %14.8f\n", *weight);
  
  free(permutationfactor);
  free(configuration);  
  return fidelity; 
}

// JS.ToDo: remove function and move code inside upper loop
double findFidelityContrib(int length, int (*configuration)[5],
  int index, double *ox, double *x, int *permutationfactor, double *ci){
  double subtotal;
  int maxm, m,y;
  int *allocation;

  allocation=(int (*)) malloc((MAX_SUBN+1)*sizeof(int));
  if (!allocation) ERR("malloc FidelityContrib"); // JS-2010-06 added

  maxm=length;
  if (FIDELITY==2)  // JS.ToDo: why?
     maxm=length/2;
  subtotal=0.0;
  (*ci)=0.0;
  
  /* go over all partitions of the cluster in 'configuration' into 
     e^S = 1 + S +1/2! S^2 + ... + 1/m! S^m + ... */
  for(m=1;m<=maxm;m++) {
    /* unfortuately, the number of such configurations for large values
    *  of m and length may be greater than the maximum integer possible. 
    *  Partition this maximum integer into pieces! */
    y=1;
    findCICoefficient(index, length, configuration, allocation,
              m, &y, ox, x, &subtotal, ci, permutationfactor);
	  
  }
  
  if (Control.output>0 && !myid) // JS: lot of output!
    printf("Nodal Surface => cluster index=%d : coefficient=%14.8f\n",
    index, *ci);
  
  free(allocation);
  return subtotal;
}

// JS.ToDo: whats about?
void findCICoefficient(int index, int length, int (*configuration)[5],
               int (*allocation), int m, int *y, 
               double *ox, double *x,double *subtotal, double *ci,
               int *permutationfactor){
  int i, j, dummy, current_length, tempNum, tempm,
      length2, l, l2, descriptorIndex,imax;
  double sum, sum2;
 
   imax=pow(m,length); /* the maximum sub-integer */

   // DJJF: need to check for integer overflow in imax -- TO DO!
   // 
   

  for(i=0;i<imax;i++){ // JS10: imax may be very big

    if (Control.output>6 && i%10000==0 && !myid)
      printf("i=%d\n",i);
 
   /* the next part allocates the spins in clusters into
       one of 'm' partitions in the 1/(m!) S^m expansion of e^S */

    dummy=i;
	
    for(j=1;j<=length;j++){
      /* how many of the sites have been reached */
      current_length=j;
      tempNum=dummy/m;
      /* note add a 1 so that the partition labels runs from 1 to m */
      allocation[current_length]=dummy-m*tempNum+1; 
      dummy=tempNum;
    }

	/* find the contribution */
   if ((i==0 || i==(imax-1) || i==(imax/2)) && Control.output>10) {
	  printf("Index=%d : y=%d : i=%d : ", index, *y, i);
	  for(l=1;l<=length;l++)  printf("%d ",allocation[l]);
	  printf("\n");
	}	

	sum=1.0;  /* running product for fidelity */
	sum2=1.0; /* running product for nodal surface */
	
	for(tempm=1;tempm<=m;tempm++) {

        length2=0; /* length of sub-cluster of type tempm */

        for(l=1;l<=length;l++) 
	      if (allocation[l]==tempm) length2++;

        int (*tempconfig)[5];
        tempconfig = (int (*)[5]) malloc( (length2+1)*5*sizeof(int) );
        if (!tempconfig) { ERR("ERROR recursion routine: malloc\n"); }
        l2=0;
     	for(l=1;l<=length;l++) {
	      if (allocation[l]==tempm) {
	        int k;
			l2++;
	        for(k=1; k<5; k++) tempconfig[l2][k] = configuration[l][k];
	      }
	    }
		
        if (length2 > 14) // JS: what is that for ????
	      printf("length2 > 14\n");

	    // descriptorIndex=findClusterIndexAgain(length2, tempconfig); // DJJF
 
	   descriptorIndex=findClusterIndex(length2, tempconfig); // JS-2010-06
	   
	   if (descriptorIndex<1 || descriptorIndex>NumberConfigurations) {
	      sum=0.0;
	      sum2=0.0;
	      free(tempconfig);
          break;
        }
        sum =sum*(x[descriptorIndex]-ox[descriptorIndex]); /* fidelity */
        sum2=sum2*x[descriptorIndex];  /* c-i coefficient for nodal surface */ 
        free(tempconfig);
      } // 1 <= tempm <= m
      *subtotal+=sum /permutationfactor[m]; /* divide by m! */
      *ci      +=sum2/permutationfactor[m]; /* divide by m! */
    } // i from 0 to imax 
}

int findEmbeddingConstant(int index){

  /*
  */

  int i1, j, k;  // JS1003: rename i to i1 for better searching
  int minR[3];  // x y z
  int OK=0, 
      is_minConfig, // -1: error (no valid cfg), 1: was min cfg? 
      err=0;  // have valid descriptor
  // int **tempConfiguration;  // obsolete
  static int tempDescriptor[DESCR_SIZE+1]={0}; // {0} against tcc-0.9.25 bug
  static int listOfDescriptors[DESCR_SIZE+1][MAX_NUM_SYM+1]={{0,0}};
  int nu,length;
										   
  // tempConfiguration=matrix(0,MAX_SUBN+1,0,5);  // to slow
  // as long as we handle animals, we need the len>=max(SUBM,SUBN)
  static int tempConfiguration[MAX_SUBM+MAX_SUBN+1][5]
            ={{0,0,0,0,0}}; // {0} against tcc-0.9.25 bug
  static int configuration[MAX_SUBM+MAX_SUBN+1][5]
            ={{0,0,0,0,0}}; // {0} against tcc-0.9.25 bug

  length=findClusterFromDescriptor(spinConfigurations[index].descriptor,
                                           configuration);
										   
  for (k=0;k<DESCR_SIZE;k++) tempDescriptor[k]=0;  
  for (k=0;k<DESCR_SIZE;k++) 
    for (j=0;j<=MAX_NUM_SYM;j++) 
      listOfDescriptors[k][j]=-1;  

  nu=1;
  for (i1=0; i1<LatticeSymmetries.number; i1++) {

    // find symmetry related clusters
    symmetryGroup(i1,length,configuration,tempConfiguration);

    // translate into correct quadrant, x>=0,y>=0,z>=0 (for BT)
    for (k=0; k<Dimension && k<Params.dim; k++) {

      minR[k]=tempConfiguration[1][k+1];

      for (j=2; j<=length; j++)
        if (minR[k] > tempConfiguration[j][k+1]) 
            minR[k] = tempConfiguration[j][k+1];

      for (j=1; j<=length; j++)
        tempConfiguration[j][k+1] -= minR[k];

      // i1==0 is no sym, reset flag if its not a minimum input config 
    }


    // now find the descriptor (costs most CPU, Joerg Oct04)
    // bitpattern (flips per site.uc) splittet to an integer array
    err= DescrFromConfig(tempDescriptor, tempConfiguration, length);
//	printf("> Index=%d : symmetry=%d : descr_size=%d\n",index,i1,DESCR_SIZE);
//	printOutDescriptor(tempDescriptor); 								   
	if (i1==0) {
	  for (k=0;k<DESCR_SIZE;k++) listOfDescriptors[k][nu]=tempDescriptor[k];
	} else {
	  OK=1;
	  for(j=1;j<=nu;j++) {
	    for(k=0;k<DESCR_SIZE;k++) { 
		  if(listOfDescriptors[k][j]!=tempDescriptor[k]) {
		    OK=0;
			break;
		  }
		}
		if (OK<1) break;
	  }
	  if (!OK) {
	    nu++;
		for (k=0;k<DESCR_SIZE;k++) listOfDescriptors[k][nu]=tempDescriptor[k];
	  }
	}
  }
  if (Control.output>0 && !myid) {
    printOutClusterFromDescriptor(spinConfigurations[index].descriptor);
    printf("Index = %d and nu =%d\n",index,nu);
  }
  return nu;
}

// findCICoefficient()
/* ^ DJJF 2 June 2010: New Fidelity Code ^ */ 
#endif // if FIDELITY
